# This definitely needs cleaning
using OrdinaryDiffEqAdamsBashforthMoulton, ODEProblemLibrary, DiffEqDevTools
using Test, Random
Random.seed!(100)

## Convergence Testing
dts1 = 1 .// 2 .^ (9:-1:5)
dts = 1 .// 2 .^ (8:-1:4)
testTol = 0.2

@testset "Explicit Solver Convergence Tests ($(["out-of-place", "in-place"][i]))" for i in
    1:2

    prob = (
        ODEProblemLibrary.prob_ode_linear,
        ODEProblemLibrary.prob_ode_2Dlinear,
    )[i]

    sim5 = test_convergence(dts, prob, AB3())
    @test sim5.𝒪est[:l2] ≈ 3 atol = testTol
    sim6 = test_convergence(dts, prob, ABM32())
    @test sim6.𝒪est[:l2] ≈ 3 atol = testTol
    sim7 = test_convergence(dts, prob, AB4())
    @test sim7.𝒪est[:l2] ≈ 4 atol = testTol
    sim8 = test_convergence(dts1, prob, ABM43())  #using dts1 due to floating point error in convergence test
    @test sim8.𝒪est[:l2] ≈ 4 atol = testTol
    sim9 = test_convergence(dts, prob, AB5())
    @test sim9.𝒪est[:l2] ≈ 5 atol = testTol
    sim10 = test_convergence(dts, prob, ABM54())
    @test sim10.𝒪est[:l2] ≈ 5 atol = testTol
    sim101 = test_convergence(dts, prob, VCAB3())
    @test sim101.𝒪est[:l2] ≈ 3 atol = testTol
    sim102 = test_convergence(dts, prob, VCAB4())
    @test sim102.𝒪est[:l2] ≈ 4 atol = testTol
    sim103 = test_convergence(dts, prob, VCAB5())
    @test sim103.𝒪est[:l2] ≈ 5 atol = testTol
    sim104 = test_convergence(dts, prob, VCABM3())
    @test sim104.𝒪est[:l2] ≈ 3 atol = testTol
    sim105 = test_convergence(dts, prob, VCABM4())
    @test sim105.𝒪est[:l2] ≈ 4 atol = testTol
    sim106 = test_convergence(dts, prob, VCABM5())
    @test sim106.𝒪est[:l2] ≈ 5 atol = testTol
end

@testset "Explicit Solver Convergence Tests ($(["out-of-place", "in-place"][i])) - threaded " for i in
    1:2

    prob = (
        ODEProblemLibrary.prob_ode_linear,
        ODEProblemLibrary.prob_ode_2Dlinear,
    )[i]

    sim5 = test_convergence(dts, prob, AB3(true))
    @test sim5.𝒪est[:l2] ≈ 3 atol = testTol
    sim7 = test_convergence(dts, prob, AB4(true))
    @test sim7.𝒪est[:l2] ≈ 4 atol = testTol
    sim9 = test_convergence(dts, prob, AB5(true))
    @test sim9.𝒪est[:l2] ≈ 5 atol = testTol
    sim101 = test_convergence(dts, prob, VCAB3(true))
    @test sim101.𝒪est[:l2] ≈ 3 atol = testTol
    sim103 = test_convergence(dts, prob, VCAB5(true))
    @test sim103.𝒪est[:l2] ≈ 5 atol = testTol
    sim105 = test_convergence(dts, prob, VCABM4(true))
    @test sim105.𝒪est[:l2] ≈ 4 atol = testTol
end

using Pkg
Pkg.add("JET")

import OrdinaryDiffEqAdamsBashforthMoulton
using JET

@testset "JET Tests" begin
    test_package(
        OrdinaryDiffEqAdamsBashforthMoulton, target_modules = (OrdinaryDiffEqAdamsBashforthMoulton,), mode = :typo
    )
end

abstract type ABMMutableCache <: OrdinaryDiffEqMutableCache end
abstract type ABMVariableCoefficientMutableCache <: OrdinaryDiffEqMutableCache end
get_fsalfirstlast(cache::ABMMutableCache, u) = (cache.fsalfirst, cache.k)
function get_fsalfirstlast(cache::ABMVariableCoefficientMutableCache, u)
    return (cache.fsalfirst, cache.k4)
end
@cache mutable struct AB3Cache{uType, rateType, Thread} <: ABMMutableCache
    u::uType
    uprev::uType
    fsalfirst::rateType
    k2::rateType
    k3::rateType
    ralk2::rateType
    k::rateType
    tmp::uType
    step::Int
    thread::Thread
end

@cache mutable struct AB3ConstantCache{rateType} <: OrdinaryDiffEqConstantCache
    k2::rateType
    k3::rateType
    step::Int
end

function alg_cache(
        alg::AB3, u, rate_prototype, ::Type{uEltypeNoUnits},
        ::Type{uBottomEltypeNoUnits}, ::Type{tTypeNoUnits}, uprev, uprev2, f, t,
        dt, reltol, p, calck,
        ::Val{true}, verbose
    ) where {uEltypeNoUnits, uBottomEltypeNoUnits, tTypeNoUnits}
    fsalfirst = zero(rate_prototype)
    k2 = zero(rate_prototype)
    k3 = zero(rate_prototype)
    ralk2 = zero(rate_prototype)
    k = zero(rate_prototype)
    tmp = zero(u)
    return AB3Cache(u, uprev, fsalfirst, k2, k3, ralk2, k, tmp, 1, alg.thread)
end

function alg_cache(
        alg::AB3, u, rate_prototype, ::Type{uEltypeNoUnits},
        ::Type{uBottomEltypeNoUnits}, ::Type{tTypeNoUnits}, uprev, uprev2, f, t,
        dt, reltol, p, calck,
        ::Val{false}, verbose
    ) where {uEltypeNoUnits, uBottomEltypeNoUnits, tTypeNoUnits}
    k2 = rate_prototype
    k3 = rate_prototype
    return AB3ConstantCache(k2, k3, 1)
end

@cache mutable struct ABM32Cache{uType, rateType, Thread} <: ABMMutableCache
    u::uType
    uprev::uType
    fsalfirst::rateType
    k2::rateType
    k3::rateType
    ralk2::rateType
    k::rateType
    tmp::uType
    step::Int
    thread::Thread
end

@cache mutable struct ABM32ConstantCache{rateType} <: OrdinaryDiffEqConstantCache
    k2::rateType
    k3::rateType
    step::Int
end

function alg_cache(
        alg::ABM32, u, rate_prototype, ::Type{uEltypeNoUnits},
        ::Type{uBottomEltypeNoUnits}, ::Type{tTypeNoUnits}, uprev, uprev2, f, t,
        dt, reltol, p, calck,
        ::Val{true}, verbose
    ) where {uEltypeNoUnits, uBottomEltypeNoUnits, tTypeNoUnits}
    fsalfirst = zero(rate_prototype)
    k2 = zero(rate_prototype)
    k3 = zero(rate_prototype)
    ralk2 = zero(rate_prototype)
    k = zero(rate_prototype)
    tmp = zero(u)
    return ABM32Cache(u, uprev, fsalfirst, k2, k3, ralk2, k, tmp, 1, alg.thread)
end

function alg_cache(
        alg::ABM32, u, rate_prototype, ::Type{uEltypeNoUnits},
        ::Type{uBottomEltypeNoUnits}, ::Type{tTypeNoUnits}, uprev, uprev2, f, t,
        dt, reltol, p, calck,
        ::Val{false}, verbose
    ) where {uEltypeNoUnits, uBottomEltypeNoUnits, tTypeNoUnits}
    k2 = rate_prototype
    k3 = rate_prototype
    return ABM32ConstantCache(k2, k3, 1)
end

@cache mutable struct AB4Cache{uType, rateType, Thread} <: ABMMutableCache
    u::uType
    uprev::uType
    fsalfirst::rateType
    k2::rateType
    k3::rateType
    k4::rateType
    ralk2::rateType
    k::rateType
    tmp::uType
    t2::rateType
    t3::rateType
    t4::rateType
    step::Int
    thread::Thread
end

@cache mutable struct AB4ConstantCache{rateType} <: OrdinaryDiffEqConstantCache
    k2::rateType
    k3::rateType
    k4::rateType
    step::Int
end

function alg_cache(
        alg::AB4, u, rate_prototype, ::Type{uEltypeNoUnits},
        ::Type{uBottomEltypeNoUnits}, ::Type{tTypeNoUnits}, uprev, uprev2, f, t,
        dt, reltol, p, calck,
        ::Val{true}, verbose
    ) where {uEltypeNoUnits, uBottomEltypeNoUnits, tTypeNoUnits}
    fsalfirst = zero(rate_prototype)
    k2 = zero(rate_prototype)
    k3 = zero(rate_prototype)
    k4 = zero(rate_prototype)
    ralk2 = zero(rate_prototype)
    k = zero(rate_prototype)
    tmp = zero(u)
    t2 = zero(rate_prototype)
    t3 = zero(rate_prototype)
    t4 = zero(rate_prototype)
    return AB4Cache(u, uprev, fsalfirst, k2, k3, k4, ralk2, k, tmp, t2, t3, t4, 1, alg.thread)
end

function alg_cache(
        alg::AB4, u, rate_prototype, ::Type{uEltypeNoUnits},
        ::Type{uBottomEltypeNoUnits}, ::Type{tTypeNoUnits}, uprev, uprev2, f, t,
        dt, reltol, p, calck,
        ::Val{false}, verbose
    ) where {uEltypeNoUnits, uBottomEltypeNoUnits, tTypeNoUnits}
    k2 = rate_prototype
    k3 = rate_prototype
    k4 = rate_prototype
    return AB4ConstantCache(k2, k3, k4, 1)
end

@cache mutable struct ABM43Cache{uType, rateType, Thread} <: ABMMutableCache
    u::uType
    uprev::uType
    fsalfirst::rateType
    k2::rateType
    k3::rateType
    k4::rateType
    ralk2::rateType
    k::rateType
    tmp::uType
    t2::rateType
    t3::rateType
    t4::rateType
    t5::rateType
    t6::rateType
    t7::rateType
    step::Int
    thread::Thread
end

@cache mutable struct ABM43ConstantCache{rateType} <: OrdinaryDiffEqConstantCache
    k2::rateType
    k3::rateType
    k4::rateType
    step::Int
end

function alg_cache(
        alg::ABM43, u, rate_prototype, ::Type{uEltypeNoUnits},
        ::Type{uBottomEltypeNoUnits}, ::Type{tTypeNoUnits}, uprev, uprev2, f, t,
        dt, reltol, p, calck,
        ::Val{true}, verbose
    ) where {uEltypeNoUnits, uBottomEltypeNoUnits, tTypeNoUnits}
    fsalfirst = zero(rate_prototype)
    k2 = zero(rate_prototype)
    k3 = zero(rate_prototype)
    k4 = zero(rate_prototype)
    ralk2 = zero(rate_prototype)
    k = zero(rate_prototype)
    tmp = zero(u)
    t2 = zero(rate_prototype)
    t3 = zero(rate_prototype)
    t4 = zero(rate_prototype)
    t5 = zero(rate_prototype)
    t6 = zero(rate_prototype)
    t7 = zero(rate_prototype)
    return ABM43Cache(
        u, uprev, fsalfirst, k2, k3, k4, ralk2, k,
        tmp, t2, t3, t4, t5, t6, t7, 1, alg.thread
    )
end

function alg_cache(
        alg::ABM43, u, rate_prototype, ::Type{uEltypeNoUnits},
        ::Type{uBottomEltypeNoUnits}, ::Type{tTypeNoUnits}, uprev, uprev2, f, t,
        dt, reltol, p, calck,
        ::Val{false}, verbose
    ) where {uEltypeNoUnits, uBottomEltypeNoUnits, tTypeNoUnits}
    k2 = rate_prototype
    k3 = rate_prototype
    k4 = rate_prototype
    return ABM43ConstantCache(k2, k3, k4, 1)
end

@cache mutable struct AB5Cache{uType, rateType, Thread} <: ABMMutableCache
    u::uType
    uprev::uType
    fsalfirst::rateType
    k2::rateType
    k3::rateType
    k4::rateType
    k5::rateType
    k::rateType
    tmp::uType
    t2::rateType
    t3::rateType
    t4::rateType
    step::Int
    thread::Thread
end

@cache mutable struct AB5ConstantCache{rateType} <: OrdinaryDiffEqConstantCache
    k2::rateType
    k3::rateType
    k4::rateType
    k5::rateType
    step::Int
end

function alg_cache(
        alg::AB5, u, rate_prototype, ::Type{uEltypeNoUnits},
        ::Type{uBottomEltypeNoUnits}, ::Type{tTypeNoUnits}, uprev, uprev2, f, t,
        dt, reltol, p, calck,
        ::Val{true}, verbose
    ) where {uEltypeNoUnits, uBottomEltypeNoUnits, tTypeNoUnits}
    fsalfirst = zero(rate_prototype)
    k2 = zero(rate_prototype)
    k3 = zero(rate_prototype)
    k4 = zero(rate_prototype)
    k5 = zero(rate_prototype)
    k = zero(rate_prototype)
    tmp = zero(u)
    t2 = zero(rate_prototype)
    t3 = zero(rate_prototype)
    t4 = zero(rate_prototype)
    return AB5Cache(u, uprev, fsalfirst, k2, k3, k4, k5, k, tmp, t2, t3, t4, 1, alg.thread)
end

function alg_cache(
        alg::AB5, u, rate_prototype, ::Type{uEltypeNoUnits},
        ::Type{uBottomEltypeNoUnits}, ::Type{tTypeNoUnits}, uprev, uprev2, f, t,
        dt, reltol, p, calck,
        ::Val{false}, verbose
    ) where {uEltypeNoUnits, uBottomEltypeNoUnits, tTypeNoUnits}
    k2 = rate_prototype
    k3 = rate_prototype
    k4 = rate_prototype
    k5 = rate_prototype
    return AB5ConstantCache(k2, k3, k4, k5, 1)
end

@cache mutable struct ABM54Cache{uType, rateType, Thread} <: ABMMutableCache
    u::uType
    uprev::uType
    fsalfirst::rateType
    k2::rateType
    k3::rateType
    k4::rateType
    k5::rateType
    k::rateType
    tmp::uType
    t2::rateType
    t3::rateType
    t4::rateType
    t5::rateType
    t6::rateType
    t7::rateType
    t8::rateType
    step::Int
    thread::Thread
end

@cache mutable struct ABM54ConstantCache{rateType} <: OrdinaryDiffEqConstantCache
    k2::rateType
    k3::rateType
    k4::rateType
    k5::rateType
    step::Int
end

function alg_cache(
        alg::ABM54, u, rate_prototype, ::Type{uEltypeNoUnits},
        ::Type{uBottomEltypeNoUnits}, ::Type{tTypeNoUnits}, uprev, uprev2, f, t,
        dt, reltol, p, calck,
        ::Val{true}, verbose
    ) where {uEltypeNoUnits, uBottomEltypeNoUnits, tTypeNoUnits}
    fsalfirst = zero(rate_prototype)
    k2 = zero(rate_prototype)
    k3 = zero(rate_prototype)
    k4 = zero(rate_prototype)
    k5 = zero(rate_prototype)
    k = zero(rate_prototype)
    tmp = zero(u)
    t2 = zero(rate_prototype)
    t3 = zero(rate_prototype)
    t4 = zero(rate_prototype)
    t5 = zero(rate_prototype)
    t6 = zero(rate_prototype)
    t7 = zero(rate_prototype)
    t8 = zero(rate_prototype)
    return ABM54Cache(
        u, uprev, fsalfirst, k2, k3, k4, k5, k, tmp,
        t2, t3, t4, t5, t6, t7, t8, 1, alg.thread
    )
end

function alg_cache(
        alg::ABM54, u, rate_prototype, ::Type{uEltypeNoUnits},
        ::Type{uBottomEltypeNoUnits}, ::Type{tTypeNoUnits}, uprev, uprev2, f, t,
        dt, reltol, p, calck,
        ::Val{false}, verbose
    ) where {uEltypeNoUnits, uBottomEltypeNoUnits, tTypeNoUnits}
    k2 = rate_prototype
    k3 = rate_prototype
    k4 = rate_prototype
    k5 = rate_prototype
    return ABM54ConstantCache(k2, k3, k4, k5, 1)
end

@cache mutable struct VCAB3ConstantCache{
        TabType, tArrayType, rArrayType, cArrayType,
        dtArrayType,
    } <: OrdinaryDiffEqConstantCache
    dts::dtArrayType
    c::cArrayType
    g::tArrayType
    ϕ_n::rArrayType
    ϕstar_nm1::rArrayType
    ϕstar_n::rArrayType
    β::tArrayType
    order::Int
    tab::TabType
    step::Int
end

@cache mutable struct VCAB3Cache{
        uType, rateType, TabType, bs3Type, tArrayType, cArrayType,
        uNoUnitsType, coefType, dtArrayType, Thread,
    } <:
    ABMVariableCoefficientMutableCache
    u::uType
    uprev::uType
    fsalfirst::rateType
    bs3cache::bs3Type
    k4::rateType
    ϕstar_nm1::coefType
    dts::dtArrayType
    c::cArrayType
    g::tArrayType
    ϕ_n::coefType
    ϕstar_n::coefType
    β::tArrayType
    order::Int
    atmp::uNoUnitsType
    tmp::uType
    utilde::uType
    tab::TabType
    step::Int
    thread::Thread
end

function alg_cache(
        alg::VCAB3, u, rate_prototype, ::Type{uEltypeNoUnits},
        ::Type{uBottomEltypeNoUnits}, ::Type{tTypeNoUnits}, uprev, uprev2, f, t,
        dt, reltol, p, calck,
        ::Val{false}, verbose
    ) where {uEltypeNoUnits, uBottomEltypeNoUnits, tTypeNoUnits}
    dts = fill(zero(dt), 3)
    c = fill(zero(t), 3, 3)
    g = fill(zero(t), 3)
    ϕ_n = Vector{typeof(rate_prototype)}(undef, 3)
    ϕstar_nm1 = Vector{typeof(rate_prototype)}(undef, 3)
    ϕstar_n = Vector{typeof(rate_prototype)}(undef, 3)
    for i in 1:3
        ϕ_n[i] = copy(rate_prototype)
        ϕstar_nm1[i] = copy(rate_prototype)
        ϕstar_n[i] = copy(rate_prototype)
    end
    β = fill(zero(t), 3)
    order = 3
    tab = BS3ConstantCache(constvalue(uBottomEltypeNoUnits), constvalue(tTypeNoUnits))
    return VCAB3ConstantCache(dts, c, g, ϕ_n, ϕstar_nm1, ϕstar_n, β, order, tab, 1)
end

function alg_cache(
        alg::VCAB3, u, rate_prototype, ::Type{uEltypeNoUnits},
        ::Type{uBottomEltypeNoUnits}, ::Type{tTypeNoUnits}, uprev, uprev2, f, t,
        dt, reltol, p, calck,
        ::Val{true}, verbose
    ) where {uEltypeNoUnits, uBottomEltypeNoUnits, tTypeNoUnits}
    tab = BS3ConstantCache(constvalue(uBottomEltypeNoUnits), constvalue(tTypeNoUnits))
    bk1 = zero(rate_prototype)
    bk2 = zero(rate_prototype)
    bk3 = zero(rate_prototype)
    bk4 = zero(rate_prototype)
    butilde = zero(u)
    batmp = similar(u, uEltypeNoUnits)
    recursivefill!(batmp, false)
    btmp = zero(u)
    bs3cache = BS3Cache(
        u, uprev, bk1, bk2, bk3, bk4, butilde, btmp, batmp, tab,
        trivial_limiter!, trivial_limiter!, False()
    )
    fsalfirst = zero(rate_prototype)
    k4 = zero(rate_prototype)
    dts = fill(zero(dt), 3)
    c = fill(zero(t), 3, 3)
    g = fill(zero(t), 3)
    ϕ_n = Vector{typeof(rate_prototype)}(undef, 3)
    ϕstar_nm1 = Vector{typeof(rate_prototype)}(undef, 3)
    ϕstar_n = Vector{typeof(rate_prototype)}(undef, 3)
    for i in 1:3
        ϕ_n[i] = zero(rate_prototype)
        ϕstar_nm1[i] = zero(rate_prototype)
        ϕstar_n[i] = zero(rate_prototype)
    end
    β = fill(zero(t), 3)
    order = 3
    atmp = similar(u, uEltypeNoUnits)
    recursivefill!(atmp, false)
    tmp = zero(u)
    utilde = zero(u)
    return VCAB3Cache(
        u, uprev, fsalfirst, bs3cache, k4, ϕstar_nm1, dts, c, g, ϕ_n, ϕstar_n, β,
        order, atmp, tmp, utilde, tab, 1, alg.thread
    )
end

@cache mutable struct VCAB4ConstantCache{
        rk4constcache, tArrayType, rArrayType, cArrayType,
        dtArrayType,
    } <: OrdinaryDiffEqConstantCache
    ϕstar_nm1::rArrayType
    dts::dtArrayType
    c::cArrayType
    g::tArrayType
    ϕ_n::rArrayType
    ϕstar_n::rArrayType
    β::tArrayType
    order::Int
    rk4constcache::rk4constcache
    step::Int
end

@cache mutable struct VCAB4Cache{
        uType, rateType, rk4cacheType, tArrayType, cArrayType,
        uNoUnitsType, coefType, dtArrayType, Thread,
    } <:
    ABMVariableCoefficientMutableCache
    u::uType
    uprev::uType
    fsalfirst::rateType
    rk4cache::rk4cacheType
    k4::rateType
    ϕstar_nm1::coefType
    dts::dtArrayType
    c::cArrayType
    g::tArrayType
    ϕ_n::coefType
    ϕstar_n::coefType
    β::tArrayType
    order::Int
    atmp::uNoUnitsType
    tmp::uType
    utilde::uType
    step::Int
    thread::Thread
end

function alg_cache(
        alg::VCAB4, u, rate_prototype, ::Type{uEltypeNoUnits},
        ::Type{uBottomEltypeNoUnits}, ::Type{tTypeNoUnits}, uprev, uprev2, f, t,
        dt, reltol, p, calck,
        ::Val{false}, verbose
    ) where {uEltypeNoUnits, uBottomEltypeNoUnits, tTypeNoUnits}
    dts = fill(zero(dt), 4)
    c = fill(zero(t), 4, 4)
    g = fill(zero(t), 4)
    ϕ_n = Vector{typeof(rate_prototype)}(undef, 4)
    ϕstar_nm1 = Vector{typeof(rate_prototype)}(undef, 4)
    ϕstar_n = Vector{typeof(rate_prototype)}(undef, 4)
    for i in 1:4
        ϕ_n[i] = copy(rate_prototype)
        ϕstar_nm1[i] = copy(rate_prototype)
        ϕstar_n[i] = copy(rate_prototype)
    end
    β = fill(zero(t), 4)
    order = 4
    rk4constcache = RK4ConstantCache()
    return VCAB4ConstantCache(ϕstar_nm1, dts, c, g, ϕ_n, ϕstar_n, β, order, rk4constcache, 1)
end

function alg_cache(
        alg::VCAB4, u, rate_prototype, ::Type{uEltypeNoUnits},
        ::Type{uBottomEltypeNoUnits}, ::Type{tTypeNoUnits}, uprev, uprev2, f, t,
        dt, reltol, p, calck,
        ::Val{true}, verbose
    ) where {uEltypeNoUnits, uBottomEltypeNoUnits, tTypeNoUnits}
    rk1 = zero(rate_prototype)
    rk2 = zero(rate_prototype)
    rk3 = zero(rate_prototype)
    rk4 = zero(rate_prototype)
    rk = zero(rate_prototype)
    rtmp = zero(u)
    ratmp = similar(u, uEltypeNoUnits)
    recursivefill!(ratmp, false)
    rk4cache = RK4Cache(
        u, uprev, rk1, rk2, rk3, rk4, rk, rtmp, ratmp, trivial_limiter!,
        trivial_limiter!, False()
    )
    fsalfirst = zero(rate_prototype)
    k4 = zero(rate_prototype)
    dts = fill(zero(dt), 4)
    c = fill(zero(t), 4, 4)
    g = fill(zero(t), 4)
    ϕ_n = Vector{typeof(rate_prototype)}(undef, 4)
    ϕstar_nm1 = Vector{typeof(rate_prototype)}(undef, 4)
    ϕstar_n = Vector{typeof(rate_prototype)}(undef, 4)
    for i in 1:4
        ϕ_n[i] = zero(rate_prototype)
        ϕstar_nm1[i] = zero(rate_prototype)
        ϕstar_n[i] = zero(rate_prototype)
    end
    β = fill(zero(t), 4)
    order = 4
    atmp = similar(u, uEltypeNoUnits)
    recursivefill!(atmp, false)
    tmp = zero(u)
    utilde = zero(u)
    return VCAB4Cache(
        u, uprev, fsalfirst, rk4cache, k4, ϕstar_nm1, dts, c, g, ϕ_n, ϕstar_n, β,
        order, atmp, tmp, utilde, 1, alg.thread
    )
end

# VCAB5

@cache mutable struct VCAB5ConstantCache{
        rk4constcache, tArrayType, rArrayType, cArrayType,
        dtArrayType,
    } <: OrdinaryDiffEqConstantCache
    ϕstar_nm1::rArrayType
    dts::dtArrayType
    c::cArrayType
    g::tArrayType
    ϕ_n::rArrayType
    ϕstar_n::rArrayType
    β::tArrayType
    order::Int
    rk4constcache::rk4constcache
    step::Int
end

@cache mutable struct VCAB5Cache{
        uType, rateType, rk4cacheType, tArrayType, cArrayType,
        uNoUnitsType, coefType, dtArrayType, Thread,
    } <:
    ABMVariableCoefficientMutableCache
    u::uType
    uprev::uType
    fsalfirst::rateType
    rk4cache::rk4cacheType
    k4::rateType
    ϕstar_nm1::coefType
    dts::dtArrayType
    c::cArrayType
    g::tArrayType
    ϕ_n::coefType
    ϕstar_n::coefType
    β::tArrayType
    order::Int
    atmp::uNoUnitsType
    tmp::uType
    utilde::uType
    step::Int
    thread::Thread
end

function alg_cache(
        alg::VCAB5, u, rate_prototype, ::Type{uEltypeNoUnits},
        ::Type{uBottomEltypeNoUnits}, ::Type{tTypeNoUnits}, uprev, uprev2, f, t,
        dt, reltol, p, calck,
        ::Val{false}, verbose
    ) where {uEltypeNoUnits, uBottomEltypeNoUnits, tTypeNoUnits}
    dts = fill(zero(dt), 5)
    c = fill(zero(t), 5, 5)
    g = fill(zero(t), 5)
    ϕ_n = Vector{typeof(rate_prototype)}(undef, 5)
    ϕstar_nm1 = Vector{typeof(rate_prototype)}(undef, 5)
    ϕstar_n = Vector{typeof(rate_prototype)}(undef, 5)
    for i in 1:5
        ϕ_n[i] = copy(rate_prototype)
        ϕstar_nm1[i] = copy(rate_prototype)
        ϕstar_n[i] = copy(rate_prototype)
    end
    β = fill(zero(t), 5)
    order = 5
    rk4constcache = RK4ConstantCache()
    return VCAB5ConstantCache(ϕstar_nm1, dts, c, g, ϕ_n, ϕstar_n, β, order, rk4constcache, 1)
end

function alg_cache(
        alg::VCAB5, u, rate_prototype, ::Type{uEltypeNoUnits},
        ::Type{uBottomEltypeNoUnits}, ::Type{tTypeNoUnits}, uprev, uprev2, f, t,
        dt, reltol, p, calck,
        ::Val{true}, verbose
    ) where {uEltypeNoUnits, uBottomEltypeNoUnits, tTypeNoUnits}
    rk1 = zero(rate_prototype)
    rk2 = zero(rate_prototype)
    rk3 = zero(rate_prototype)
    rk4 = zero(rate_prototype)
    rk = zero(rate_prototype)
    rtmp = zero(u)
    ratmp = similar(u, uEltypeNoUnits)
    recursivefill!(ratmp, false)
    rk4cache = RK4Cache(
        u, uprev, rk1, rk2, rk3, rk4, rk, rtmp, ratmp, trivial_limiter!,
        trivial_limiter!, False()
    )
    fsalfirst = zero(rate_prototype)
    k4 = zero(rate_prototype)
    dts = fill(zero(dt), 5)
    c = fill(zero(t), 5, 5)
    g = fill(zero(t), 5)
    ϕ_n = Vector{typeof(rate_prototype)}(undef, 5)
    ϕstar_nm1 = Vector{typeof(rate_prototype)}(undef, 5)
    ϕstar_n = Vector{typeof(rate_prototype)}(undef, 5)
    for i in 1:5
        ϕ_n[i] = zero(rate_prototype)
        ϕstar_nm1[i] = zero(rate_prototype)
        ϕstar_n[i] = zero(rate_prototype)
    end
    β = fill(zero(t), 5)
    order = 5
    atmp = similar(u, uEltypeNoUnits)
    recursivefill!(atmp, false)
    tmp = zero(u)
    utilde = zero(u)
    return VCAB5Cache(
        u, uprev, fsalfirst, rk4cache, k4, ϕstar_nm1, dts, c, g, ϕ_n, ϕstar_n, β,
        order, atmp, tmp, utilde, 1, alg.thread
    )
end

# VCABM3

@cache mutable struct VCABM3ConstantCache{
        TabType, tArrayType, rArrayType, cArrayType,
        dtArrayType,
    } <: OrdinaryDiffEqConstantCache
    dts::dtArrayType
    c::cArrayType
    g::tArrayType
    ϕ_n::rArrayType
    ϕ_np1::rArrayType
    ϕstar_nm1::rArrayType
    ϕstar_n::rArrayType
    β::tArrayType
    order::Int
    tab::TabType
    step::Int
end

@cache mutable struct VCABM3Cache{
        uType, rateType, TabType, bs3Type, tArrayType, cArrayType,
        uNoUnitsType, coefType, dtArrayType, Thread,
    } <:
    ABMVariableCoefficientMutableCache
    u::uType
    uprev::uType
    fsalfirst::rateType
    bs3cache::bs3Type
    k4::rateType
    ϕstar_nm1::coefType
    dts::dtArrayType
    c::cArrayType
    g::tArrayType
    ϕ_n::coefType
    ϕ_np1::coefType
    ϕstar_n::coefType
    β::tArrayType
    order::Int
    atmp::uNoUnitsType
    tmp::uType
    utilde::uType
    tab::TabType
    step::Int
    thread::Thread
end

function alg_cache(
        alg::VCABM3, u, rate_prototype, ::Type{uEltypeNoUnits},
        ::Type{uBottomEltypeNoUnits}, ::Type{tTypeNoUnits}, uprev, uprev2, f, t,
        dt, reltol, p, calck,
        ::Val{false}, verbose
    ) where {uEltypeNoUnits, uBottomEltypeNoUnits, tTypeNoUnits}
    dts = fill(zero(dt), 3)
    c = fill(zero(t), 4, 4)
    g = fill(zero(t), 4)
    ϕ_n = Vector{typeof(rate_prototype)}(undef, 3)
    ϕstar_nm1 = Vector{typeof(rate_prototype)}(undef, 3)
    ϕstar_n = Vector{typeof(rate_prototype)}(undef, 3)
    ϕ_np1 = Vector{typeof(rate_prototype)}(undef, 4)
    for i in 1:3
        ϕ_n[i] = copy(rate_prototype)
        ϕstar_nm1[i] = copy(rate_prototype)
        ϕstar_n[i] = copy(rate_prototype)
    end
    β = fill(zero(t), 3)
    order = 3
    tab = BS3ConstantCache(constvalue(uBottomEltypeNoUnits), constvalue(tTypeNoUnits))
    return VCABM3ConstantCache(dts, c, g, ϕ_n, ϕ_np1, ϕstar_nm1, ϕstar_n, β, order, tab, 1)
end

function alg_cache(
        alg::VCABM3, u, rate_prototype, ::Type{uEltypeNoUnits},
        ::Type{uBottomEltypeNoUnits}, ::Type{tTypeNoUnits}, uprev, uprev2, f, t,
        dt, reltol, p, calck,
        ::Val{true}, verbose
    ) where {uEltypeNoUnits, uBottomEltypeNoUnits, tTypeNoUnits}
    tab = BS3ConstantCache(constvalue(uBottomEltypeNoUnits), constvalue(tTypeNoUnits))
    bk1 = zero(rate_prototype)
    bk2 = zero(rate_prototype)
    bk3 = zero(rate_prototype)
    bk4 = zero(rate_prototype)
    butilde = zero(u)
    batmp = similar(u, uEltypeNoUnits)
    recursivefill!(batmp, false)
    btmp = zero(u)
    bs3cache = BS3Cache(
        u, uprev, bk1, bk2, bk3, bk4, butilde, btmp, batmp, tab,
        trivial_limiter!, trivial_limiter!, False()
    )
    fsalfirst = zero(rate_prototype)
    k4 = zero(rate_prototype)
    dts = fill(zero(dt), 3)
    c = fill(zero(t), 4, 4)
    g = fill(zero(t), 4)
    ϕ_n = Vector{typeof(rate_prototype)}(undef, 3)
    ϕstar_nm1 = Vector{typeof(rate_prototype)}(undef, 3)
    ϕstar_n = Vector{typeof(rate_prototype)}(undef, 3)
    ϕ_np1 = Vector{typeof(rate_prototype)}(undef, 4)
    for i in 1:3
        ϕ_n[i] = zero(rate_prototype)
        ϕstar_nm1[i] = zero(rate_prototype)
        ϕstar_n[i] = zero(rate_prototype)
    end
    for i in 1:4
        ϕ_np1[i] = zero(rate_prototype)
    end
    β = fill(zero(t), 3)
    order = 3
    atmp = similar(u, uEltypeNoUnits)
    recursivefill!(atmp, false)
    tmp = zero(u)
    utilde = zero(u)
    return VCABM3Cache(
        u, uprev, fsalfirst, bs3cache, k4, ϕstar_nm1, dts, c, g, ϕ_n, ϕ_np1,
        ϕstar_n, β, order, atmp, tmp, utilde, tab, 1, alg.thread
    )
end

# VCABM4

@cache mutable struct VCABM4ConstantCache{
        rk4constcache, tArrayType, rArrayType, cArrayType,
        dtArrayType,
    } <: OrdinaryDiffEqConstantCache
    ϕstar_nm1::rArrayType
    dts::dtArrayType
    c::cArrayType
    g::tArrayType
    ϕ_n::rArrayType
    ϕ_np1::rArrayType
    ϕstar_n::rArrayType
    β::tArrayType
    order::Int
    rk4constcache::rk4constcache
    step::Int
end

@cache mutable struct VCABM4Cache{
        uType, rateType, rk4cacheType, tArrayType, cArrayType,
        uNoUnitsType, coefType, dtArrayType, Thread,
    } <:
    ABMVariableCoefficientMutableCache
    u::uType
    uprev::uType
    fsalfirst::rateType
    rk4cache::rk4cacheType
    k4::rateType
    ϕstar_nm1::coefType
    dts::dtArrayType
    c::cArrayType
    g::tArrayType
    ϕ_n::coefType
    ϕ_np1::coefType
    ϕstar_n::coefType
    β::tArrayType
    order::Int
    atmp::uNoUnitsType
    tmp::uType
    utilde::uType
    step::Int
    thread::Thread
end

function alg_cache(
        alg::VCABM4, u, rate_prototype, ::Type{uEltypeNoUnits},
        ::Type{uBottomEltypeNoUnits}, ::Type{tTypeNoUnits}, uprev, uprev2, f, t,
        dt, reltol, p, calck,
        ::Val{false}, verbose
    ) where {uEltypeNoUnits, uBottomEltypeNoUnits, tTypeNoUnits}
    dts = fill(zero(dt), 4)
    c = fill(zero(t), 5, 5)
    g = fill(zero(t), 5)
    ϕ_n = Vector{typeof(rate_prototype)}(undef, 4)
    ϕstar_nm1 = Vector{typeof(rate_prototype)}(undef, 4)
    ϕstar_n = Vector{typeof(rate_prototype)}(undef, 4)
    ϕ_np1 = Vector{typeof(rate_prototype)}(undef, 5)
    for i in 1:4
        ϕ_n[i] = copy(rate_prototype)
        ϕstar_nm1[i] = copy(rate_prototype)
        ϕstar_n[i] = copy(rate_prototype)
    end
    β = fill(zero(t), 4)
    order = 4
    rk4constcache = RK4ConstantCache()
    return VCABM4ConstantCache(
        ϕstar_nm1, dts, c, g, ϕ_n, ϕ_np1, ϕstar_n, β, order, rk4constcache,
        1
    )
end

function alg_cache(
        alg::VCABM4, u, rate_prototype, ::Type{uEltypeNoUnits},
        ::Type{uBottomEltypeNoUnits}, ::Type{tTypeNoUnits}, uprev, uprev2, f, t,
        dt, reltol, p, calck,
        ::Val{true}, verbose
    ) where {uEltypeNoUnits, uBottomEltypeNoUnits, tTypeNoUnits}
    rk1 = zero(rate_prototype)
    rk2 = zero(rate_prototype)
    rk3 = zero(rate_prototype)
    rk4 = zero(rate_prototype)
    rk = zero(rate_prototype)
    rtmp = zero(u)
    ratmp = similar(u, uEltypeNoUnits)
    recursivefill!(ratmp, false)
    rk4cache = RK4Cache(
        u, uprev, rk1, rk2, rk3, rk4, rk, rtmp, ratmp, trivial_limiter!,
        trivial_limiter!, False()
    )
    fsalfirst = zero(rate_prototype)
    k4 = zero(rate_prototype)
    dts = fill(zero(dt), 4)
    c = fill(zero(t), 5, 5)
    g = fill(zero(t), 5)
    ϕ_n = Vector{typeof(rate_prototype)}(undef, 4)
    ϕstar_nm1 = Vector{typeof(rate_prototype)}(undef, 4)
    ϕstar_n = Vector{typeof(rate_prototype)}(undef, 4)
    ϕ_np1 = Vector{typeof(rate_prototype)}(undef, 5)
    for i in 1:4
        ϕ_n[i] = zero(rate_prototype)
        ϕstar_nm1[i] = zero(rate_prototype)
        ϕstar_n[i] = zero(rate_prototype)
    end
    for i in 1:5
        ϕ_np1[i] = zero(rate_prototype)
    end
    β = fill(zero(t), 4)
    order = 4
    atmp = similar(u, uEltypeNoUnits)
    recursivefill!(atmp, false)
    tmp = zero(u)
    utilde = zero(u)
    return VCABM4Cache(
        u, uprev, fsalfirst, rk4cache, k4, ϕstar_nm1, dts, c, g, ϕ_n, ϕ_np1,
        ϕstar_n, β, order, atmp, tmp, utilde, 1, alg.thread
    )
end

# VCABM5

@cache mutable struct VCABM5ConstantCache{
        rk4constcache, tArrayType, rArrayType, cArrayType,
        dtArrayType,
    } <: OrdinaryDiffEqConstantCache
    ϕstar_nm1::rArrayType
    dts::dtArrayType
    c::cArrayType
    g::tArrayType
    ϕ_n::rArrayType
    ϕ_np1::rArrayType
    ϕstar_n::rArrayType
    β::tArrayType
    order::Int
    rk4constcache::rk4constcache
    step::Int
end

@cache mutable struct VCABM5Cache{
        uType, rateType, rk4cacheType, tArrayType, cArrayType,
        uNoUnitsType, coefType, dtArrayType, Thread,
    } <:
    ABMVariableCoefficientMutableCache
    u::uType
    uprev::uType
    fsalfirst::rateType
    rk4cache::rk4cacheType
    k4::rateType
    ϕstar_nm1::coefType
    dts::dtArrayType
    c::cArrayType
    g::tArrayType
    ϕ_n::coefType
    ϕ_np1::coefType
    ϕstar_n::coefType
    β::tArrayType
    order::Int
    atmp::uNoUnitsType
    tmp::uType
    utilde::uType
    step::Int
    thread::Thread
end

function alg_cache(
        alg::VCABM5, u, rate_prototype, ::Type{uEltypeNoUnits},
        ::Type{uBottomEltypeNoUnits}, ::Type{tTypeNoUnits}, uprev, uprev2, f, t,
        dt, reltol, p, calck,
        ::Val{false}, verbose
    ) where {uEltypeNoUnits, uBottomEltypeNoUnits, tTypeNoUnits}
    dts = fill(zero(t), 5)
    c = fill(zero(t), 6, 6)
    g = fill(zero(t), 6)
    ϕ_n = Vector{typeof(rate_prototype)}(undef, 5)
    ϕstar_nm1 = Vector{typeof(rate_prototype)}(undef, 5)
    ϕstar_n = Vector{typeof(rate_prototype)}(undef, 5)
    ϕ_np1 = Vector{typeof(rate_prototype)}(undef, 6)
    for i in 1:5
        ϕ_n[i] = copy(rate_prototype)
        ϕstar_nm1[i] = copy(rate_prototype)
        ϕstar_n[i] = copy(rate_prototype)
    end
    β = fill(zero(t), 5)
    order = 5
    rk4constcache = RK4ConstantCache()
    return VCABM5ConstantCache(
        ϕstar_nm1, dts, c, g, ϕ_n, ϕ_np1, ϕstar_n, β, order, rk4constcache,
        1
    )
end

function alg_cache(
        alg::VCABM5, u, rate_prototype, ::Type{uEltypeNoUnits},
        ::Type{uBottomEltypeNoUnits}, ::Type{tTypeNoUnits}, uprev, uprev2, f, t,
        dt, reltol, p, calck,
        ::Val{true}, verbose
    ) where {uEltypeNoUnits, uBottomEltypeNoUnits, tTypeNoUnits}
    rk1 = zero(rate_prototype)
    rk2 = zero(rate_prototype)
    rk3 = zero(rate_prototype)
    rk4 = zero(rate_prototype)
    rk = zero(rate_prototype)
    rtmp = zero(u)
    ratmp = similar(u, uEltypeNoUnits)
    recursivefill!(ratmp, false)
    rk4cache = RK4Cache(
        u, uprev, rk1, rk2, rk3, rk4, rk, rtmp, ratmp, trivial_limiter!,
        trivial_limiter!, False()
    )
    fsalfirst = zero(rate_prototype)
    k4 = zero(rate_prototype)
    dts = fill(zero(dt), 5)
    c = fill(zero(t), 6, 6)
    g = fill(zero(t), 6)
    ϕ_n = Vector{typeof(rate_prototype)}(undef, 5)
    ϕstar_nm1 = Vector{typeof(rate_prototype)}(undef, 5)
    ϕstar_n = Vector{typeof(rate_prototype)}(undef, 5)
    ϕ_np1 = Vector{typeof(rate_prototype)}(undef, 6)
    for i in 1:5
        ϕ_n[i] = zero(rate_prototype)
        ϕstar_nm1[i] = zero(rate_prototype)
        ϕstar_n[i] = zero(rate_prototype)
    end
    for i in 1:6
        ϕ_np1[i] = zero(rate_prototype)
    end
    β = fill(zero(t), 5)
    order = 5
    atmp = similar(u, uEltypeNoUnits)
    recursivefill!(atmp, false)
    tmp = zero(u)
    utilde = zero(u)
    return VCABM5Cache(
        u, uprev, fsalfirst, rk4cache, k4, ϕstar_nm1, dts, c, g, ϕ_n, ϕ_np1,
        ϕstar_n, β, order, atmp, tmp, utilde, 1, alg.thread
    )
end

# VCABM

@cache mutable struct VCABMConstantCache{
        tArrayType, rArrayType, cArrayType, dtType,
        dtArrayType,
    } <: OrdinaryDiffEqConstantCache
    ϕstar_nm1::rArrayType
    dts::dtArrayType
    c::cArrayType
    g::tArrayType
    ϕ_n::rArrayType
    ϕ_np1::rArrayType
    ϕstar_n::rArrayType
    β::tArrayType
    ξ::dtType
    ξ0::dtType
    order::Int
    max_order::Int
    step::Int
end

@cache mutable struct VCABMCache{
        uType, rateType, dtType, tArrayType, cArrayType,
        uNoUnitsType, coefType, dtArrayType, Thread,
    } <:
    ABMVariableCoefficientMutableCache
    u::uType
    uprev::uType
    fsalfirst::rateType
    k4::rateType
    ϕstar_nm1::coefType
    dts::dtArrayType
    c::cArrayType
    g::tArrayType
    ϕ_n::coefType
    ϕ_np1::coefType
    ϕstar_n::coefType
    β::tArrayType
    order::Int
    max_order::Int
    atmp::uNoUnitsType
    tmp::uType
    ξ::dtType
    ξ0::dtType
    utilde::uType
    utildem1::uType
    utildem2::uType
    utildep1::uType
    atmpm1::uNoUnitsType
    atmpm2::uNoUnitsType
    atmpp1::uNoUnitsType
    step::Int
    thread::Thread
end

function alg_cache(
        alg::VCABM, u, rate_prototype, ::Type{uEltypeNoUnits},
        ::Type{uBottomEltypeNoUnits}, ::Type{tTypeNoUnits}, uprev, uprev2, f, t,
        dt, reltol, p, calck,
        ::Val{false}, verbose
    ) where {uEltypeNoUnits, uBottomEltypeNoUnits, tTypeNoUnits}
    dts = fill(zero(dt), 13)
    c = fill(zero(t), 13, 13)
    g = fill(zero(t), 13)
    ϕ_n = Vector{typeof(rate_prototype)}(undef, 13)
    ϕstar_nm1 = Vector{typeof(rate_prototype)}(undef, 13)
    ϕstar_n = Vector{typeof(rate_prototype)}(undef, 13)
    ϕ_np1 = Vector{typeof(rate_prototype)}(undef, 14)
    for i in 1:13
        ϕ_n[i] = copy(rate_prototype)
        ϕstar_nm1[i] = copy(rate_prototype)
        ϕstar_n[i] = copy(rate_prototype)
    end
    β = fill(zero(t), 13)
    ξ = zero(dt)
    ξ0 = zero(dt)
    order = 1
    max_order = 12
    return VCABMConstantCache(
        ϕstar_nm1, dts, c, g, ϕ_n, ϕ_np1, ϕstar_n, β, ξ, ξ0, order,
        max_order, 1
    )
end

function alg_cache(
        alg::VCABM, u, rate_prototype, ::Type{uEltypeNoUnits},
        ::Type{uBottomEltypeNoUnits}, ::Type{tTypeNoUnits}, uprev, uprev2, f, t,
        dt, reltol, p, calck,
        ::Val{true}, verbose
    ) where {uEltypeNoUnits, uBottomEltypeNoUnits, tTypeNoUnits}
    fsalfirst = zero(rate_prototype)
    k4 = zero(rate_prototype)
    dts = fill(zero(dt), 13)
    c = fill(zero(t), 13, 13)
    g = fill(zero(t), 13)
    ϕ_n = Vector{typeof(rate_prototype)}(undef, 13)
    ϕstar_nm1 = Vector{typeof(rate_prototype)}(undef, 13)
    ϕstar_n = Vector{typeof(rate_prototype)}(undef, 13)
    ϕ_np1 = Vector{typeof(rate_prototype)}(undef, 14)
    for i in 1:13
        ϕ_n[i] = zero(rate_prototype)
        ϕstar_nm1[i] = zero(rate_prototype)
        ϕstar_n[i] = zero(rate_prototype)
    end
    for i in 1:14
        ϕ_np1[i] = zero(rate_prototype)
    end
    β = fill(zero(t), 13)
    order = 1
    max_order = 12
    atmp = similar(u, uEltypeNoUnits)
    recursivefill!(atmp, false)
    tmp = zero(u)
    ξ = zero(dt)
    ξ0 = zero(dt)
    utilde = zero(u)
    utildem2 = zero(u)
    utildem1 = zero(u)
    utildep1 = zero(u)
    atmp = similar(u, uEltypeNoUnits)
    recursivefill!(atmp, false)
    atmpm1 = similar(u, uEltypeNoUnits)
    recursivefill!(atmpm1, false)
    atmpm2 = similar(u, uEltypeNoUnits)
    recursivefill!(atmpm2, false)
    atmpp1 = similar(u, uEltypeNoUnits)
    recursivefill!(atmpp1, false)
    return VCABMCache(
        u, uprev, fsalfirst, k4, ϕstar_nm1, dts, c, g, ϕ_n, ϕ_np1, ϕstar_n, β, order,
        max_order, atmp, tmp, ξ, ξ0, utilde, utildem1, utildem2, utildep1, atmpm1,
        atmpm2, atmpp1, 1, alg.thread
    )
end

function initialize!(
        integrator,
        cache::Union{
            AB3ConstantCache,
            AB4ConstantCache,
            AB5ConstantCache,
            ABM32ConstantCache,
            ABM43ConstantCache,
            ABM54ConstantCache,
        }
    )
    integrator.fsalfirst = integrator.f(integrator.uprev, integrator.p, integrator.t) # Pre-start fsal
    OrdinaryDiffEqCore.increment_nf!(integrator.stats, 1)
    integrator.kshortsize = 2
    integrator.k = typeof(integrator.k)(undef, integrator.kshortsize)

    # Avoid undefined entries if k is an array of arrays
    integrator.fsallast = zero(integrator.fsalfirst)
    integrator.k[1] = integrator.fsalfirst
    return integrator.k[2] = integrator.fsallast
end

function initialize!(
        integrator,
        cache::Union{
            AB3Cache,
            AB4Cache,
            AB5Cache,
            ABM32Cache,
            ABM43Cache,
            ABM54Cache,
        }
    )
    (; fsalfirst, k) = cache

    integrator.kshortsize = 2
    resize!(integrator.k, integrator.kshortsize)
    integrator.k[1] = integrator.fsalfirst
    integrator.k[2] = integrator.fsallast
    integrator.f(integrator.fsalfirst, integrator.uprev, integrator.p, integrator.t) # pre-start FSAL
    return OrdinaryDiffEqCore.increment_nf!(integrator.stats, 1)
end

@muladd function perform_step!(integrator, cache::AB3ConstantCache, repeat_step = false)
    (; t, dt, uprev, u, f, p) = integrator
    (; k2, k3) = cache
    k1 = integrator.fsalfirst
    if integrator.u_modified
        cache.step = 1
    end
    cnt = cache.step
    if cache.step <= 2
        cache.step += 1
        ttmp = t + (2 / 3) * dt
        ralk2 = f(uprev + (2 / 3) * dt * k1, p, ttmp)       #Ralston Method
        OrdinaryDiffEqCore.increment_nf!(integrator.stats, 1)
        u = uprev + (dt / 4) * (k1 + 3 * ralk2)
        if cnt == 1
            k3 = k1
        else
            k2 = k1
        end
    else
        u = uprev + (dt / 12) * (23 * k1 - 16 * k2 + 5 * k3)
        k3 = k2
        k2 = k1
    end
    cache.k2 = k2
    cache.k3 = k3
    integrator.fsallast = f(u, p, t + dt)
    OrdinaryDiffEqCore.increment_nf!(integrator.stats, 1)
    integrator.k[1] = integrator.fsalfirst
    integrator.k[2] = integrator.fsallast
    integrator.u = u
end

@muladd function perform_step!(integrator, cache::AB3Cache, repeat_step = false)
    (; t, dt, uprev, u, f, p) = integrator
    (; tmp, fsalfirst, k2, k3, ralk2, k, thread) = cache
    k1 = integrator.fsalfirst
    if integrator.u_modified
        cache.step = 1
    end
    cnt = cache.step
    if cache.step <= 2
        cache.step += 1
        ttmp = t + (2 / 3) * dt
        @.. broadcast = false thread = thread tmp = uprev + (2 / 3) * dt * k1
        f(ralk2, tmp, p, ttmp)
        OrdinaryDiffEqCore.increment_nf!(integrator.stats, 1)
        @.. broadcast = false thread = thread u = uprev + (dt / 4) * (k1 + 3 * ralk2)        #Ralston Method
        if cnt == 1
            cache.k3 .= k1
        else
            cache.k2 .= k1
        end
    else
        @.. broadcast = false thread = thread u = uprev + (dt / 12) * (23 * k1 - 16 * k2 + 5 * k3)
        cache.k2, cache.k3 = k3, k2
        cache.k2 .= k1
    end
    f(k, u, p, t + dt)
    OrdinaryDiffEqCore.increment_nf!(integrator.stats, 1)
end

@muladd function perform_step!(integrator, cache::ABM32ConstantCache, repeat_step = false)
    (; t, dt, uprev, u, f, p) = integrator
    (; k2, k3) = cache
    k1 = integrator.fsalfirst
    if integrator.u_modified
        cache.step = 1
    end
    cnt = cache.step
    if cache.step == 1
        cache.step += 1
        ttmp = t + (2 / 3) * dt
        ralk2 = f(uprev + (2 / 3) * dt * k1, p, ttmp)     #Ralston Method
        OrdinaryDiffEqCore.increment_nf!(integrator.stats, 1)
        u = uprev + (dt / 4) * (k1 + 3 * ralk2)
        k2 = k1
    else
        perform_step!(integrator, AB3ConstantCache(k2, k3, cnt))
        k = integrator.fsallast
        u = uprev + (dt / 12) * (5 * k + 8 * k1 - k2)
        k3 = k2
        k2 = k1
    end
    cache.k2 = k2
    cache.k3 = k3
    integrator.fsallast = f(u, p, t + dt)
    OrdinaryDiffEqCore.increment_nf!(integrator.stats, 1)
    integrator.k[1] = integrator.fsalfirst
    integrator.k[2] = integrator.fsallast
    integrator.u = u
end

@muladd function perform_step!(integrator, cache::ABM32Cache, repeat_step = false)
    (; t, dt, uprev, u, f, p) = integrator
    (; tmp, fsalfirst, k2, k3, ralk2, k, thread) = cache
    k1 = integrator.fsalfirst
    if integrator.u_modified
        cache.step = 1
    end
    cnt = cache.step
    if cache.step == 1
        cache.step += 1
        ttmp = t + (2 / 3) * dt
        @.. broadcast = false thread = thread tmp = uprev + (2 / 3) * dt * k1
        f(ralk2, tmp, p, ttmp)
        OrdinaryDiffEqCore.increment_nf!(integrator.stats, 1)
        @.. broadcast = false thread = thread u = uprev + (dt / 4) * (k1 + 3 * ralk2)       #Ralston Method
        cache.k2 .= k1
    else
        if cnt == 2
            perform_step!(
                integrator,
                AB3Cache(u, uprev, fsalfirst, copy(k2), k3, ralk2, k, tmp, cnt, thread)
            )  #Here passing copy of k2, otherwise it will change in AB3()
        else
            perform_step!(
                integrator,
                AB3Cache(u, uprev, fsalfirst, k2, k3, ralk2, k, tmp, cnt, thread)
            )
        end
        k = integrator.fsallast
        @.. broadcast = false thread = thread u = uprev + (dt / 12) * (5 * k + 8 * k1 - k2)
        cache.k2, cache.k3 = k3, k2
        cache.k2 .= k1
    end
    f(k, u, p, t + dt)
    OrdinaryDiffEqCore.increment_nf!(integrator.stats, 1)
end

@muladd function perform_step!(integrator, cache::AB4ConstantCache, repeat_step = false)
    (; t, dt, uprev, u, f, p) = integrator
    (; k2, k3, k4) = cache
    k1 = integrator.fsalfirst
    if integrator.u_modified
        cache.step = 1
    end
    cnt = cache.step
    if cache.step <= 3
        cache.step += 1
        halfdt = dt / 2
        ttmp = t + halfdt
        k2 = f(uprev + halfdt * k1, p, ttmp)
        k3 = f(uprev + halfdt * k2, p, ttmp)
        k4 = f(uprev + dt * k3, p, t + dt)
        OrdinaryDiffEqCore.increment_nf!(integrator.stats, 3)
        u = uprev + (dt / 6) * (2 * (k2 + k3) + (k1 + k4))   #RK4
        if cnt == 1
            cache.k4 = k1
        elseif cnt == 2
            cache.k3 = k1
        else
            cache.k2 = k1
        end
    else
        u = uprev + (dt / 24) * (55 * k1 - 59 * k2 + 37 * k3 - 9 * k4)
        cache.k4 = k3
        cache.k3 = k2
        cache.k2 = k1
    end
    integrator.fsallast = f(u, p, t + dt)
    OrdinaryDiffEqCore.increment_nf!(integrator.stats, 1)
    integrator.k[1] = integrator.fsalfirst
    integrator.k[2] = integrator.fsallast
    integrator.u = u
end

@muladd function perform_step!(integrator, cache::AB4Cache, repeat_step = false)
    (; t, dt, uprev, u, f, p) = integrator
    (; tmp, fsalfirst, k2, k3, k4, ralk2, k, t2, t3, t4, thread) = cache
    k1 = integrator.fsalfirst
    if integrator.u_modified
        cache.step = 1
    end
    cnt = cache.step
    if cache.step <= 3
        cache.step += 1
        halfdt = dt / 2
        ttmp = t + halfdt
        @.. broadcast = false thread = thread tmp = uprev + halfdt * k1
        f(t2, tmp, p, ttmp)
        @.. broadcast = false thread = thread tmp = uprev + halfdt * t2
        f(t3, tmp, p, ttmp)
        @.. broadcast = false thread = thread tmp = uprev + dt * t3
        f(t4, tmp, p, t + dt)
        OrdinaryDiffEqCore.increment_nf!(integrator.stats, 3)
        @.. broadcast = false thread = thread u = uprev + (dt / 6) * (2 * (t2 + t3) + (k1 + t4))   #RK4
        if cnt == 1
            cache.k4 .= k1
        elseif cnt == 2
            cache.k3 .= k1
        else
            cache.k2 .= k1
        end
    else
        @.. broadcast = false thread = thread u = uprev +
            (dt / 24) *
            (55 * k1 - 59 * k2 + 37 * k3 - 9 * k4)
        cache.k4, cache.k3 = k3, k4
        cache.k3 .= k2
        cache.k2 .= k1
    end
    f(k, u, p, t + dt)
    OrdinaryDiffEqCore.increment_nf!(integrator.stats, 1)
end

@muladd function perform_step!(integrator, cache::ABM43ConstantCache, repeat_step = false)
    (; t, dt, uprev, u, f, p) = integrator
    (; k2, k3, k4) = cache
    k1 = integrator.fsalfirst
    if integrator.u_modified
        cache.step = 1
    end
    cnt = cache.step
    if cache.step <= 2
        cache.step += 1
        halfdt = dt / 2
        ttmp = t + halfdt
        k2 = f(uprev + halfdt * k1, p, ttmp)
        k3 = f(uprev + halfdt * k2, p, ttmp)
        k4 = f(uprev + dt * k3, p, t + dt)
        OrdinaryDiffEqCore.increment_nf!(integrator.stats, 3)
        u = uprev + (dt / 6) * (2 * (k2 + k3) + (k1 + k4))   #RK4
        if cnt == 1
            cache.k3 = k1
        else
            cache.k2 = k1
        end
    else
        perform_step!(integrator, AB4ConstantCache(k2, k3, k4, cnt))
        k = integrator.fsallast
        u = uprev + (dt / 24) * (9 * k + 19 * k1 - 5 * k2 + k3)
        cache.k4 = k3
        cache.k3 = k2
        cache.k2 = k1
    end
    integrator.fsallast = f(u, p, t + dt)
    OrdinaryDiffEqCore.increment_nf!(integrator.stats, 1)
    integrator.k[1] = integrator.fsalfirst
    integrator.k[2] = integrator.fsallast
    integrator.u = u
end

@muladd function perform_step!(integrator, cache::ABM43Cache, repeat_step = false)
    (; t, dt, uprev, u, f, p) = integrator
    (; tmp, fsalfirst, k2, k3, k4, ralk2, k, t2, t3, t4, t5, t6, t7, thread) = cache
    k1 = integrator.fsalfirst
    if integrator.u_modified
        cache.step = 1
    end
    cnt = cache.step
    if cache.step <= 2
        cache.step += 1
        halfdt = dt / 2
        ttmp = t + halfdt
        @.. broadcast = false thread = thread tmp = uprev + halfdt * k1
        f(t2, tmp, p, ttmp)
        @.. broadcast = false thread = thread tmp = uprev + halfdt * t2
        f(t3, tmp, p, ttmp)
        @.. broadcast = false thread = thread tmp = uprev + dt * t3
        f(t4, tmp, p, t + dt)
        OrdinaryDiffEqCore.increment_nf!(integrator.stats, 3)
        @.. broadcast = false thread = thread u = uprev + (dt / 6) * (2 * (t2 + t3) + (k1 + t4))   #RK4
        if cnt == 1
            cache.k3 .= k1
        else
            cache.k2 .= k1
        end
    else
        t2 .= k2
        t3 .= k3
        t4 .= k4
        perform_step!(
            integrator,
            AB4Cache(
                u, uprev, fsalfirst, t2, t3, t4, ralk2, k, tmp, t5, t6, t7,
                cnt, thread
            )
        )
        k = integrator.fsallast
        @.. broadcast = false thread = thread u = uprev +
            (dt / 24) * (9 * k + 19 * k1 - 5 * k2 + k3)
        cache.k4, cache.k3 = k3, k4
        cache.k3 .= k2
        cache.k2 .= k1
    end
    f(k, u, p, t + dt)
    OrdinaryDiffEqCore.increment_nf!(integrator.stats, 1)
end

@muladd function perform_step!(integrator, cache::AB5ConstantCache, repeat_step = false)
    (; t, dt, uprev, u, f, p) = integrator
    (; k2, k3, k4, k5) = cache
    k1 = integrator.fsalfirst
    if integrator.u_modified
        cache.step = 1
    end
    if cache.step <= 4
        cnt = cache.step
        cache.step += 1
        halfdt = dt / 2
        ttmp = t + halfdt
        k2 = f(uprev + halfdt * k1, p, ttmp)
        k3 = f(uprev + halfdt * k2, p, ttmp)
        k4 = f(uprev + dt * k3, p, t + dt)
        OrdinaryDiffEqCore.increment_nf!(integrator.stats, 3)
        u = uprev + (dt / 6) * (2 * (k2 + k3) + (k1 + k4))  #RK4
        if cnt == 1
            cache.k5 = k1
        elseif cnt == 2
            cache.k4 = k1
        elseif cnt == 3
            cache.k3 = k1
        else
            cache.k2 = k1
        end
    else
        u = uprev + (dt / 720) * (1901 * k1 - 2774 * k2 + 2616 * k3 - 1274 * k4 + 251 * k5)
        cache.k5 = k4
        cache.k4 = k3
        cache.k3 = k2
        cache.k2 = k1
    end
    integrator.fsallast = f(u, p, t + dt)
    OrdinaryDiffEqCore.increment_nf!(integrator.stats, 1)
    integrator.k[1] = integrator.fsalfirst
    integrator.k[2] = integrator.fsallast
    integrator.u = u
end

@muladd function perform_step!(integrator, cache::AB5Cache, repeat_step = false)
    (; t, dt, uprev, u, f, p) = integrator
    (; tmp, fsalfirst, k2, k3, k4, k5, k, t2, t3, t4, thread) = cache
    k1 = integrator.fsalfirst
    if integrator.u_modified
        cache.step = 1
    end
    cnt = cache.step
    if cache.step <= 4
        cache.step += 1
        halfdt = dt / 2
        ttmp = t + halfdt
        @.. broadcast = false thread = thread tmp = uprev + halfdt * k1
        f(t2, tmp, p, ttmp)
        @.. broadcast = false thread = thread tmp = uprev + halfdt * t2
        f(t3, tmp, p, ttmp)
        @.. broadcast = false thread = thread tmp = uprev + dt * t3
        f(t4, tmp, p, t + dt)
        OrdinaryDiffEqCore.increment_nf!(integrator.stats, 1)
        @.. broadcast = false thread = thread u = uprev + (dt / 6) * (2 * (t2 + t3) + (k1 + t4))   #RK4
        if cnt == 1
            cache.k5 .= k1
        elseif cnt == 2
            cache.k4 .= k1
        elseif cnt == 3
            cache.k3 .= k1
        else
            cache.k2 .= k1
        end
    else
        @.. broadcast = false thread = thread u = uprev +
            (dt / 720) *
            (
            1901 * k1 - 2774 * k2 + 2616 * k3 - 1274 * k4 +
                251 * k5
        )
        cache.k5, cache.k4 = k4, k5
        cache.k4 .= k3
        cache.k3 .= k2
        cache.k2 .= k1
    end
    f(k, u, p, t + dt)
    OrdinaryDiffEqCore.increment_nf!(integrator.stats, 1)
end

@muladd function perform_step!(integrator, cache::ABM54ConstantCache, repeat_step = false)
    (; t, dt, uprev, u, f, p) = integrator
    (; k2, k3, k4, k5) = cache
    k1 = integrator.fsalfirst
    if integrator.u_modified
        cache.step = 1
    end
    cnt = cache.step
    if cache.step <= 3
        cache.step += 1
        halfdt = dt / 2
        ttmp = t + halfdt
        k2 = f(uprev + halfdt * k1, p, ttmp)
        k3 = f(uprev + halfdt * k2, p, ttmp)
        k4 = f(uprev + dt * k3, p, t + dt)
        OrdinaryDiffEqCore.increment_nf!(integrator.stats, 3)
        u = uprev + (dt / 6) * (2 * (k2 + k3) + (k1 + k4))   #RK4
        if cnt == 1
            cache.k4 = k1
        elseif cnt == 2
            cache.k3 = k1
        else
            cache.k2 = k1
        end
    else
        perform_step!(integrator, AB5ConstantCache(k2, k3, k4, k5, cnt))
        k = integrator.fsallast
        u = uprev + (dt / 720) * (251 * k + 646 * k1 - 264 * k2 + 106 * k3 - 19 * k4)
        cache.k5 = k4
        cache.k4 = k3
        cache.k3 = k2
        cache.k2 = k1
    end
    integrator.fsallast = f(u, p, t + dt)
    OrdinaryDiffEqCore.increment_nf!(integrator.stats, 1)
    integrator.k[1] = integrator.fsalfirst
    integrator.k[2] = integrator.fsallast
    integrator.u = u
end

@muladd function perform_step!(integrator, cache::ABM54Cache, repeat_step = false)
    (; t, dt, uprev, u, f, p) = integrator
    (; tmp, fsalfirst, k2, k3, k4, k5, k, t2, t3, t4, t5, t6, t7, t8, thread) = cache
    k1 = integrator.fsalfirst
    if integrator.u_modified
        cache.step = 1
    end
    cnt = cache.step
    if cache.step <= 3
        cache.step += 1
        halfdt = dt / 2
        ttmp = t + halfdt
        @.. broadcast = false thread = thread tmp = uprev + halfdt * k1
        f(t2, tmp, p, ttmp)
        @.. broadcast = false thread = thread tmp = uprev + halfdt * t2
        f(t3, tmp, p, ttmp)
        @.. broadcast = false thread = thread tmp = uprev + dt * t3
        f(t4, tmp, p, t + dt)
        @.. broadcast = false thread = thread u = uprev + (dt / 6) * (2 * (t2 + t3) + (k1 + t4))   #RK4
        OrdinaryDiffEqCore.increment_nf!(integrator.stats, 3)
        if cnt == 1
            cache.k4 .= k1
        elseif cnt == 2
            cache.k3 .= k1
        else
            cache.k2 .= k1
        end
    else
        t2 .= k2
        t3 .= k3
        t4 .= k4
        t5 .= k5
        perform_step!(
            integrator,
            AB5Cache(
                u, uprev, fsalfirst, t2, t3, t4, t5, k, tmp, t6, t7, t8,
                cnt, thread
            )
        )
        k = integrator.fsallast
        @.. broadcast = false thread = thread u = uprev +
            (dt / 720) *
            (
            251 * k + 646 * k1 - 264 * k2 + 106 * k3 -
                19 * k4
        )
        cache.k5, cache.k4 = k4, k5
        cache.k4 .= k3
        cache.k3 .= k2
        cache.k2 .= k1
    end
    f(k, u, p, t + dt)
    OrdinaryDiffEqCore.increment_nf!(integrator.stats, 1)
end

# Variable Step Size Multistep Methods

function initialize!(integrator, cache::VCAB3ConstantCache)
    integrator.fsalfirst = integrator.f(integrator.uprev, integrator.p, integrator.t) # Pre-start fsal
    integrator.kshortsize = 2
    integrator.k = typeof(integrator.k)(undef, integrator.kshortsize)

    # Avoid undefined entries if k is an array of arrays
    integrator.fsallast = zero(integrator.fsalfirst)
    integrator.k[1] = integrator.fsalfirst
    return integrator.k[2] = integrator.fsallast
end

@muladd function perform_step!(integrator, cache::VCAB3ConstantCache, repeat_step = false)
    (; t, dt, uprev, u, f, p) = integrator
    (; dts, g, ϕ_n, ϕstar_n, ϕstar_nm1, order, tab) = cache
    k1 = integrator.fsalfirst
    if integrator.u_modified
        cache.step = 1
    end
    k = cache.step
    tmp = dts[3]
    if k == 1
        dts[1] = dt
        cache.step += 1
    elseif k == 2
        dts[2] = dts[1]
        dts[1] = dt
        cache.step += 1
    else
        dts[3] = dts[2]
        dts[2] = dts[1]
        dts[1] = dt
    end
    ϕ_and_ϕstar!(cache, k1, k)
    if k == 1 || k == 2
        perform_step!(integrator, tab)
    else
        g_coefs!(cache, k)
        u = uprev
        for i in 1:k
            u += g[i] * ϕstar_n[i]
        end
        if integrator.opts.adaptive
            utilde = g[k] * ϕstar_n[k]      # Using lower order AB from subset of coefficients
            atmp = calculate_residuals(
                utilde, uprev, u, integrator.opts.abstol,
                integrator.opts.reltol, integrator.opts.internalnorm,
                t
            )
            integrator.EEst = integrator.opts.internalnorm(atmp, t)
            if integrator.EEst > one(integrator.EEst)
                for i in 1:2
                    dts[i] = dts[i + 1]
                end
                dts[3] = tmp
                return nothing
            end
        end
        integrator.fsallast = f(u, p, t + dt)
        OrdinaryDiffEqCore.increment_nf!(integrator.stats, 1)
        integrator.k[1] = integrator.fsalfirst
        integrator.k[2] = integrator.fsallast
        integrator.u = u
    end
    cache.ϕstar_nm1, cache.ϕstar_n = ϕstar_n, ϕstar_nm1
end

function initialize!(integrator, cache::VCAB3Cache)
    (; fsalfirst, k4) = cache

    integrator.kshortsize = 2
    resize!(integrator.k, integrator.kshortsize)
    integrator.k[1] = integrator.fsalfirst
    integrator.k[2] = integrator.fsallast
    integrator.f(integrator.fsalfirst, integrator.uprev, integrator.p, integrator.t) # pre-start FSAL
    return OrdinaryDiffEqCore.increment_nf!(integrator.stats, 1)
end

@muladd function perform_step!(integrator, cache::VCAB3Cache, repeat_step = false)
    (; t, dt, uprev, u, f, p) = integrator
    (; k4, dts, g, ϕstar_n, ϕstar_nm1, order, atmp, utilde, bs3cache, thread) = cache
    k1 = integrator.fsalfirst
    if integrator.u_modified
        cache.step = 1
    end
    k = cache.step
    tmp = dts[3]
    if k == 1
        dts[1] = dt
        cache.step += 1
    elseif k == 2
        dts[2] = dts[1]
        dts[1] = dt
        cache.step += 1
    else
        dts[3] = dts[2]
        dts[2] = dts[1]
        dts[1] = dt
    end
    ϕ_and_ϕstar!(cache, k1, k)
    if k == 1 || k == 2
        perform_step!(integrator, bs3cache)
        (; k4) = bs3cache
        integrator.fsallast .= k4
    else
        g_coefs!(cache, k)
        @.. broadcast = false thread = thread u = uprev
        for i in 1:k
            @.. broadcast = false thread = thread u += g[i] * ϕstar_n[i]
        end
        if integrator.opts.adaptive
            @.. broadcast = false thread = thread utilde = g[k] * ϕstar_n[k]    # Using lower order AB from subset of coefficients
            calculate_residuals!(
                atmp, utilde, uprev, u, integrator.opts.abstol,
                integrator.opts.reltol, integrator.opts.internalnorm, t
            )
            integrator.EEst = integrator.opts.internalnorm(atmp, t)
            if integrator.EEst > one(integrator.EEst)
                for i in 1:2
                    dts[i] = dts[i + 1]
                end
                dts[3] = tmp
                return nothing
            end
        end
        f(k4, u, p, t + dt)
        OrdinaryDiffEqCore.increment_nf!(integrator.stats, 1)
    end
    cache.ϕstar_nm1, cache.ϕstar_n = ϕstar_n, ϕstar_nm1
end

function initialize!(integrator, cache::VCAB4ConstantCache)
    integrator.fsalfirst = integrator.f(integrator.uprev, integrator.p, integrator.t) # Pre-start fsal
    OrdinaryDiffEqCore.increment_nf!(integrator.stats, 1)
    integrator.kshortsize = 2
    integrator.k = typeof(integrator.k)(undef, integrator.kshortsize)

    # Avoid undefined entries if k is an array of arrays
    integrator.fsallast = zero(integrator.fsalfirst)
    integrator.k[1] = integrator.fsalfirst
    return integrator.k[2] = integrator.fsallast
end

@muladd function perform_step!(integrator, cache::VCAB4ConstantCache, repeat_step = false)
    (; t, dt, uprev, u, f, p) = integrator
    (; dts, g, ϕ_n, ϕstar_n, ϕstar_nm1, order, rk4constcache) = cache
    k1 = integrator.fsalfirst
    if integrator.u_modified
        cache.step = 1
    end
    k = cache.step
    tmp = dts[4]
    if k == 1
        dts[1] = dt
        cache.step += 1
    elseif k == 2
        dts[2] = dts[1]
        dts[1] = dt
        cache.step += 1
    elseif k == 3
        dts[3] = dts[2]
        dts[2] = dts[1]
        dts[1] = dt
        cache.step += 1
    else
        dts[4] = dts[3]
        dts[3] = dts[2]
        dts[2] = dts[1]
        dts[1] = dt
    end
    ϕ_and_ϕstar!(cache, k1, k)
    if k == 1 || k == 2 || k == 3
        perform_step!(integrator, rk4constcache)
    else
        g_coefs!(cache, k)
        u = uprev
        for i in 1:k
            u += g[i] * ϕstar_n[i]
        end
        if integrator.opts.adaptive
            utilde = g[k] * ϕstar_n[k]
            atmp = calculate_residuals(
                utilde, uprev, u, integrator.opts.abstol,
                integrator.opts.reltol, integrator.opts.internalnorm,
                t
            )
            integrator.EEst = integrator.opts.internalnorm(atmp, t)
            if integrator.EEst > one(integrator.EEst)
                for i in 1:3
                    dts[i] = dts[i + 1]
                end
                dts[4] = tmp
                return nothing
            end
        end
        integrator.fsallast = f(u, p, t + dt)
        OrdinaryDiffEqCore.increment_nf!(integrator.stats, 1)
        integrator.k[1] = integrator.fsalfirst
        integrator.k[2] = integrator.fsallast
        integrator.u = u
    end
    cache.ϕstar_nm1, cache.ϕstar_n = ϕstar_n, ϕstar_nm1
end

function initialize!(integrator, cache::VCAB4Cache)
    (; fsalfirst, k4) = cache

    integrator.kshortsize = 2
    resize!(integrator.k, integrator.kshortsize)
    integrator.k[1] = integrator.fsalfirst
    integrator.k[2] = integrator.fsallast
    integrator.f(integrator.fsalfirst, integrator.uprev, integrator.p, integrator.t) # pre-start FSAL
    return OrdinaryDiffEqCore.increment_nf!(integrator.stats, 1)
end

@muladd function perform_step!(integrator, cache::VCAB4Cache, repeat_step = false)
    (; t, dt, uprev, u, f, p) = integrator
    (;
        k4, dts, g, ϕ_n, ϕstar_n, ϕstar_nm1, order, atmp, utilde, rk4cache,
        thread,
    ) = cache
    k1 = integrator.fsalfirst
    if integrator.u_modified
        cache.step = 1
    end
    k = cache.step
    tmp = dts[4]
    if k == 1
        dts[1] = dt
        cache.step += 1
    elseif k == 2
        dts[2] = dts[1]
        dts[1] = dt
        cache.step += 1
    elseif k == 3
        dts[3] = dts[2]
        dts[2] = dts[1]
        dts[1] = dt
        cache.step += 1
    else
        dts[4] = dts[3]
        dts[3] = dts[2]
        dts[2] = dts[1]
        dts[1] = dt
    end
    ϕ_and_ϕstar!(cache, k1, k)
    if k == 1 || k == 2 || k == 3
        rk4cache.fsalfirst .= k1
        perform_step!(integrator, rk4cache)
        integrator.fsallast .= rk4cache.k
    else
        g_coefs!(cache, k)
        @.. broadcast = false thread = thread u = uprev
        for i in 1:k
            @.. broadcast = false thread = thread u += g[i] * ϕstar_n[i]
        end
        if integrator.opts.adaptive
            @.. broadcast = false thread = thread utilde = g[k] * ϕstar_n[k]
            calculate_residuals!(
                atmp, utilde, uprev, u, integrator.opts.abstol,
                integrator.opts.reltol, integrator.opts.internalnorm, t
            )
            integrator.EEst = integrator.opts.internalnorm(atmp, t)
            if integrator.EEst > one(integrator.EEst)
                for i in 1:3
                    dts[i] = dts[i + 1]
                end
                dts[4] = tmp
                return nothing
            end
        end
        f(k4, u, p, t + dt)
        OrdinaryDiffEqCore.increment_nf!(integrator.stats, 1)
    end
    cache.ϕstar_nm1, cache.ϕstar_n = ϕstar_n, ϕstar_nm1
end

# VCAB5

function initialize!(integrator, cache::VCAB5ConstantCache)
    integrator.fsalfirst = integrator.f(integrator.uprev, integrator.p, integrator.t) # Pre-start fsal
    OrdinaryDiffEqCore.increment_nf!(integrator.stats, 1)
    integrator.kshortsize = 2
    integrator.k = typeof(integrator.k)(undef, integrator.kshortsize)

    # Avoid undefined entries if k is an array of arrays
    integrator.fsallast = zero(integrator.fsalfirst)
    integrator.k[1] = integrator.fsalfirst
    return integrator.k[2] = integrator.fsallast
end

@muladd function perform_step!(integrator, cache::VCAB5ConstantCache, repeat_step = false)
    (; t, dt, uprev, u, f, p) = integrator
    (; dts, g, ϕ_n, ϕstar_n, ϕstar_nm1, order, rk4constcache) = cache
    k1 = integrator.fsalfirst
    if integrator.u_modified
        cache.step = 1
    end
    k = cache.step
    tmp = dts[5]
    if k == 1
        dts[1] = dt
        cache.step += 1
    elseif k == 2
        dts[2] = dts[1]
        dts[1] = dt
        cache.step += 1
    elseif k == 3
        dts[3] = dts[2]
        dts[2] = dts[1]
        dts[1] = dt
        cache.step += 1
    elseif k == 4
        dts[4] = dts[3]
        dts[3] = dts[2]
        dts[2] = dts[1]
        dts[1] = dt
        cache.step += 1
    else
        dts[5] = dts[4]
        dts[4] = dts[3]
        dts[3] = dts[2]
        dts[2] = dts[1]
        dts[1] = dt
    end
    ϕ_and_ϕstar!(cache, k1, k)
    if k == 1 || k == 2 || k == 3 || k == 4
        perform_step!(integrator, rk4constcache)
    else
        g_coefs!(cache, k)
        u = uprev
        for i in 1:k
            u += g[i] * ϕstar_n[i]
        end
        if integrator.opts.adaptive
            utilde = g[k] * ϕstar_n[k]
            atmp = calculate_residuals(
                utilde, uprev, u, integrator.opts.abstol,
                integrator.opts.reltol, integrator.opts.internalnorm,
                t
            )
            integrator.EEst = integrator.opts.internalnorm(atmp, t)
            if integrator.EEst > one(integrator.EEst)
                for i in 1:4
                    dts[i] = dts[i + 1]
                end
                dts[5] = tmp
                return nothing
            end
        end
        integrator.fsallast = f(u, p, t + dt)
        OrdinaryDiffEqCore.increment_nf!(integrator.stats, 1)
        integrator.k[1] = integrator.fsalfirst
        integrator.k[2] = integrator.fsallast
        integrator.u = u
    end
    cache.ϕstar_nm1, cache.ϕstar_n = ϕstar_n, ϕstar_nm1
end

function initialize!(integrator, cache::VCAB5Cache)
    (; fsalfirst, k4) = cache

    integrator.kshortsize = 2
    resize!(integrator.k, integrator.kshortsize)
    integrator.k[1] = integrator.fsalfirst
    integrator.k[2] = integrator.fsallast
    integrator.f(integrator.fsalfirst, integrator.uprev, integrator.p, integrator.t) # pre-start FSAL
    return OrdinaryDiffEqCore.increment_nf!(integrator.stats, 1)
end

@muladd function perform_step!(integrator, cache::VCAB5Cache, repeat_step = false)
    (; t, dt, uprev, u, f, p) = integrator
    (;
        k4, dts, g, ϕ_n, ϕstar_n, ϕstar_nm1, order, atmp, utilde, rk4cache,
        thread,
    ) = cache
    k1 = integrator.fsalfirst
    if integrator.u_modified
        cache.step = 1
    end
    k = cache.step
    tmp = dts[5]
    if k == 1
        dts[1] = dt
        cache.step += 1
    elseif k == 2
        dts[2] = dts[1]
        dts[1] = dt
        cache.step += 1
    elseif k == 3
        dts[3] = dts[2]
        dts[2] = dts[1]
        dts[1] = dt
        cache.step += 1
    elseif k == 4
        dts[4] = dts[3]
        dts[3] = dts[2]
        dts[2] = dts[1]
        dts[1] = dt
        cache.step += 1
    else
        dts[5] = dts[4]
        dts[4] = dts[3]
        dts[3] = dts[2]
        dts[2] = dts[1]
        dts[1] = dt
    end
    ϕ_and_ϕstar!(cache, k1, k)
    if k == 1 || k == 2 || k == 3 || k == 4
        rk4cache.fsalfirst .= k1
        perform_step!(integrator, rk4cache)
        integrator.fsallast .= rk4cache.k
    else
        g_coefs!(cache, k)
        @.. broadcast = false thread = thread u = uprev
        for i in 1:k
            @.. broadcast = false thread = thread u += g[i] * ϕstar_n[i]
        end
        if integrator.opts.adaptive
            @.. broadcast = false thread = thread utilde = g[k] * ϕstar_n[k]
            calculate_residuals!(
                atmp, utilde, uprev, u, integrator.opts.abstol,
                integrator.opts.reltol, integrator.opts.internalnorm, t
            )
            integrator.EEst = integrator.opts.internalnorm(atmp, t)
            if integrator.EEst > one(integrator.EEst)
                for i in 1:4
                    dts[i] = dts[i + 1]
                end
                dts[5] = tmp
                return nothing
            end
        end
        f(k4, u, p, t + dt)
        OrdinaryDiffEqCore.increment_nf!(integrator.stats, 1)
    end
    cache.ϕstar_nm1, cache.ϕstar_n = ϕstar_n, ϕstar_nm1
end

# VCABM3

function initialize!(integrator, cache::VCABM3ConstantCache)
    integrator.fsalfirst = integrator.f(integrator.uprev, integrator.p, integrator.t) # Pre-start fsal
    OrdinaryDiffEqCore.increment_nf!(integrator.stats, 1)
    integrator.kshortsize = 2
    integrator.k = typeof(integrator.k)(undef, integrator.kshortsize)

    # Avoid undefined entries if k is an array of arrays
    integrator.fsallast = zero(integrator.fsalfirst)
    integrator.k[1] = integrator.fsalfirst
    return integrator.k[2] = integrator.fsallast
end

@muladd function perform_step!(integrator, cache::VCABM3ConstantCache, repeat_step = false)
    (; t, dt, uprev, u, f, p) = integrator
    (; dts, g, ϕ_n, ϕ_np1, ϕstar_n, ϕstar_nm1, order, tab) = cache
    k1 = integrator.fsalfirst
    if integrator.u_modified
        cache.step = 1
    end
    k = cache.step
    tmp = dts[3]
    if k == 1
        dts[1] = dt
        cache.step += 1
    elseif k == 2
        dts[2] = dts[1]
        dts[1] = dt
        cache.step += 1
    else
        dts[3] = dts[2]
        dts[2] = dts[1]
        dts[1] = dt
    end
    ϕ_and_ϕstar!(cache, k1, k)
    if k == 1 || k == 2
        perform_step!(integrator, tab)
    else
        g_coefs!(cache, k + 1)
        u = uprev
        for i in 1:(k - 1)
            u += g[i] * ϕstar_n[i]
        end
        du_np1 = f(u, p, t + dt)
        OrdinaryDiffEqCore.increment_nf!(integrator.stats, 1)
        ϕ_np1!(cache, du_np1, k + 1)
        u += g[end - 1] * ϕ_np1[end - 1]
        if integrator.opts.adaptive
            utilde = (g[end] - g[end - 1]) * ϕ_np1[end]
            atmp = calculate_residuals(
                utilde, uprev, u, integrator.opts.abstol,
                integrator.opts.reltol, integrator.opts.internalnorm,
                t
            )
            integrator.EEst = integrator.opts.internalnorm(atmp, t)
            if integrator.EEst > one(integrator.EEst)
                for i in 1:2
                    dts[i] = dts[i + 1]
                end
                dts[3] = tmp
                return nothing
            end
        end
        integrator.fsallast = f(u, p, t + dt)
        OrdinaryDiffEqCore.increment_nf!(integrator.stats, 1)
        integrator.k[1] = integrator.fsalfirst
        integrator.k[2] = integrator.fsallast
        integrator.u = u
    end
    cache.ϕstar_nm1, cache.ϕstar_n = ϕstar_n, ϕstar_nm1
end

function initialize!(integrator, cache::VCABM3Cache)
    (; fsalfirst, k4) = cache

    integrator.kshortsize = 2
    resize!(integrator.k, integrator.kshortsize)
    integrator.k[1] = integrator.fsalfirst
    integrator.k[2] = integrator.fsallast
    integrator.f(integrator.fsalfirst, integrator.uprev, integrator.p, integrator.t) # pre-start FSAL
    return OrdinaryDiffEqCore.increment_nf!(integrator.stats, 1)
end

@muladd function perform_step!(integrator, cache::VCABM3Cache, repeat_step = false)
    (; t, dt, uprev, u, f, p) = integrator
    (;
        k4, dts, g, ϕstar_n, ϕ_np1, ϕstar_nm1, order, atmp, utilde, bs3cache,
        thread,
    ) = cache
    k1 = integrator.fsalfirst
    if integrator.u_modified
        cache.step = 1
    end
    k = cache.step
    tmp = dts[3]
    if k == 1
        dts[1] = dt
        cache.step += 1
    elseif k == 2
        dts[2] = dts[1]
        dts[1] = dt
        cache.step += 1
    else
        dts[3] = dts[2]
        dts[2] = dts[1]
        dts[1] = dt
    end
    ϕ_and_ϕstar!(cache, k1, k)
    if k == 1 || k == 2
        perform_step!(integrator, bs3cache)
        (; k4) = bs3cache
        integrator.fsallast .= k4
    else
        g_coefs!(cache, k + 1)
        @.. broadcast = false thread = thread u = uprev
        for i in 1:(k - 1)
            @.. broadcast = false thread = thread u += g[i] * ϕstar_n[i]
        end
        f(k4, u, p, t + dt)
        OrdinaryDiffEqCore.increment_nf!(integrator.stats, 1)
        ϕ_np1!(cache, k4, k + 1)
        @.. broadcast = false thread = thread u += g[end - 1] * ϕ_np1[end - 1]
        if integrator.opts.adaptive
            @.. broadcast = false thread = thread utilde = (g[end] - g[end - 1]) * ϕ_np1[end]
            calculate_residuals!(
                atmp, utilde, uprev, u, integrator.opts.abstol,
                integrator.opts.reltol, integrator.opts.internalnorm, t
            )
            integrator.EEst = integrator.opts.internalnorm(atmp, t)
            if integrator.EEst > one(integrator.EEst)
                for i in 1:2
                    dts[i] = dts[i + 1]
                end
                dts[3] = tmp
                return nothing
            end
        end
        f(k4, u, p, t + dt)
        OrdinaryDiffEqCore.increment_nf!(integrator.stats, 1)
    end
    cache.ϕstar_nm1, cache.ϕstar_n = ϕstar_n, ϕstar_nm1
end

# VCABM4

function initialize!(integrator, cache::VCABM4ConstantCache)
    integrator.fsalfirst = integrator.f(integrator.uprev, integrator.p, integrator.t) # Pre-start fsal
    OrdinaryDiffEqCore.increment_nf!(integrator.stats, 1)
    integrator.kshortsize = 2
    integrator.k = typeof(integrator.k)(undef, integrator.kshortsize)

    # Avoid undefined entries if k is an array of arrays
    integrator.fsallast = zero(integrator.fsalfirst)
    integrator.k[1] = integrator.fsalfirst
    return integrator.k[2] = integrator.fsallast
end

@muladd function perform_step!(integrator, cache::VCABM4ConstantCache, repeat_step = false)
    (; t, dt, uprev, u, f, p) = integrator
    (; dts, g, ϕ_n, ϕ_np1, ϕstar_n, ϕstar_nm1, order, rk4constcache) = cache
    k1 = integrator.fsalfirst
    if integrator.u_modified
        cache.step = 1
    end
    k = cache.step
    tmp = dts[4]
    if k == 1
        dts[1] = dt
        cache.step += 1
    elseif k == 2
        dts[2] = dts[1]
        dts[1] = dt
        cache.step += 1
    elseif k == 3
        dts[3] = dts[2]
        dts[2] = dts[1]
        dts[1] = dt
        cache.step += 1
    else
        dts[4] = dts[3]
        dts[3] = dts[2]
        dts[2] = dts[1]
        dts[1] = dt
    end
    ϕ_and_ϕstar!(cache, k1, k)
    if k == 1 || k == 2 || k == 3
        perform_step!(integrator, rk4constcache)
    else
        g_coefs!(cache, k + 1)
        u = uprev
        for i in 1:(k - 1)
            u += g[i] * ϕstar_n[i]
        end
        du_np1 = f(u, p, t + dt)
        OrdinaryDiffEqCore.increment_nf!(integrator.stats, 1)
        ϕ_np1!(cache, du_np1, k + 1)
        u += g[end - 1] * ϕ_np1[end - 1]
        if integrator.opts.adaptive
            utilde = (g[end] - g[end - 1]) * ϕ_np1[end]
            atmp = calculate_residuals(
                utilde, uprev, u, integrator.opts.abstol,
                integrator.opts.reltol, integrator.opts.internalnorm,
                t
            )
            integrator.EEst = integrator.opts.internalnorm(atmp, t)
            if integrator.EEst > one(integrator.EEst)
                for i in 1:3
                    dts[i] = dts[i + 1]
                end
                dts[4] = tmp
                return nothing
            end
        end
        integrator.fsallast = f(u, p, t + dt)
        OrdinaryDiffEqCore.increment_nf!(integrator.stats, 1)
        integrator.k[1] = integrator.fsalfirst
        integrator.k[2] = integrator.fsallast
        integrator.u = u
    end
    cache.ϕstar_nm1, cache.ϕstar_n = ϕstar_n, ϕstar_nm1
end

function initialize!(integrator, cache::VCABM4Cache)
    (; fsalfirst, k4) = cache

    integrator.kshortsize = 2
    resize!(integrator.k, integrator.kshortsize)
    integrator.k[1] = integrator.fsalfirst
    integrator.k[2] = integrator.fsallast
    integrator.f(integrator.fsalfirst, integrator.uprev, integrator.p, integrator.t) # pre-start FSAL
    return OrdinaryDiffEqCore.increment_nf!(integrator.stats, 1)
end

@muladd function perform_step!(integrator, cache::VCABM4Cache, repeat_step = false)
    (; t, dt, uprev, u, f, p) = integrator
    (;
        k4, dts, g, ϕstar_n, ϕ_np1, ϕstar_nm1, order, atmp, utilde, rk4cache,
        thread,
    ) = cache
    k1 = integrator.fsalfirst
    if integrator.u_modified
        cache.step = 1
    end
    k = cache.step
    tmp = dts[4]
    if k == 1
        dts[1] = dt
        cache.step += 1
    elseif k == 2
        dts[2] = dts[1]
        dts[1] = dt
        cache.step += 1
    elseif k == 3
        dts[3] = dts[2]
        dts[2] = dts[1]
        dts[1] = dt
        cache.step += 1
    else
        dts[4] = dts[3]
        dts[3] = dts[2]
        dts[2] = dts[1]
        dts[1] = dt
    end
    ϕ_and_ϕstar!(cache, k1, k)
    if k == 1 || k == 2 || k == 3
        rk4cache.fsalfirst .= k1
        perform_step!(integrator, rk4cache)
        integrator.fsallast .= rk4cache.k
    else
        g_coefs!(cache, k + 1)
        @.. broadcast = false thread = thread u = uprev
        for i in 1:(k - 1)
            @.. broadcast = false thread = thread u += g[i] * ϕstar_n[i]
        end
        f(k4, u, p, t + dt)
        OrdinaryDiffEqCore.increment_nf!(integrator.stats, 1)
        ϕ_np1!(cache, k4, k + 1)
        @.. broadcast = false thread = thread u += g[end - 1] * ϕ_np1[end - 1]
        if integrator.opts.adaptive
            @.. broadcast = false thread = thread utilde = (g[end] - g[end - 1]) * ϕ_np1[end]
            calculate_residuals!(
                atmp, utilde, uprev, u, integrator.opts.abstol,
                integrator.opts.reltol, integrator.opts.internalnorm, t
            )
            integrator.EEst = integrator.opts.internalnorm(atmp, t)
            if integrator.EEst > one(integrator.EEst)
                for i in 1:3
                    dts[i] = dts[i + 1]
                end
                dts[4] = tmp
                return nothing
            end
        end
        f(k4, u, p, t + dt)
        OrdinaryDiffEqCore.increment_nf!(integrator.stats, 1)
    end
    cache.ϕstar_nm1, cache.ϕstar_n = ϕstar_n, ϕstar_nm1
end

# VCABM5

function initialize!(integrator, cache::VCABM5ConstantCache)
    integrator.fsalfirst = integrator.f(integrator.uprev, integrator.p, integrator.t) # Pre-start fsal
    OrdinaryDiffEqCore.increment_nf!(integrator.stats, 1)
    integrator.kshortsize = 2
    integrator.k = typeof(integrator.k)(undef, integrator.kshortsize)

    # Avoid undefined entries if k is an array of arrays
    integrator.fsallast = zero(integrator.fsalfirst)
    integrator.k[1] = integrator.fsalfirst
    return integrator.k[2] = integrator.fsallast
end

@muladd function perform_step!(integrator, cache::VCABM5ConstantCache, repeat_step = false)
    (; t, dt, uprev, u, f, p) = integrator
    (; dts, g, ϕ_n, ϕ_np1, ϕstar_n, ϕstar_nm1, order, rk4constcache) = cache
    k1 = integrator.fsalfirst
    if integrator.u_modified
        cache.step = 1
    end
    k = cache.step
    tmp = dts[5]
    if k == 1
        dts[1] = dt
        cache.step += 1
    elseif k == 2
        dts[2] = dts[1]
        dts[1] = dt
        cache.step += 1
    elseif k == 3
        dts[3] = dts[2]
        dts[2] = dts[1]
        dts[1] = dt
        cache.step += 1
    elseif k == 4
        dts[4] = dts[3]
        dts[3] = dts[2]
        dts[2] = dts[1]
        dts[1] = dt
        cache.step += 1
    else
        dts[5] = dts[4]
        dts[4] = dts[3]
        dts[3] = dts[2]
        dts[2] = dts[1]
        dts[1] = dt
    end
    ϕ_and_ϕstar!(cache, k1, k)
    if k == 1 || k == 2 || k == 3 || k == 4
        perform_step!(integrator, rk4constcache)
    else
        g_coefs!(cache, k + 1)
        u = uprev
        for i in 1:(k - 1)
            u += g[i] * ϕstar_n[i]
        end
        du_np1 = f(u, p, t + dt)
        OrdinaryDiffEqCore.increment_nf!(integrator.stats, 1)
        ϕ_np1!(cache, du_np1, k + 1)
        u += g[end - 1] * ϕ_np1[end - 1]
        if integrator.opts.adaptive
            utilde = (g[end] - g[end - 1]) * ϕ_np1[end]
            atmp = calculate_residuals(
                utilde, uprev, u, integrator.opts.abstol,
                integrator.opts.reltol, integrator.opts.internalnorm,
                t
            )
            integrator.EEst = integrator.opts.internalnorm(atmp, t)
            if integrator.EEst > one(integrator.EEst)
                for i in 1:4
                    dts[i] = dts[i + 1]
                end
                dts[5] = tmp
                return nothing
            end
        end
        integrator.fsallast = f(u, p, t + dt)
        OrdinaryDiffEqCore.increment_nf!(integrator.stats, 1)
        integrator.k[1] = integrator.fsalfirst
        integrator.k[2] = integrator.fsallast
        integrator.u = u
    end
    cache.ϕstar_nm1, cache.ϕstar_n = ϕstar_n, ϕstar_nm1
end

function initialize!(integrator, cache::VCABM5Cache)
    (; fsalfirst, k4) = cache

    integrator.kshortsize = 2
    resize!(integrator.k, integrator.kshortsize)
    integrator.k[1] = integrator.fsalfirst
    integrator.k[2] = integrator.fsallast
    integrator.f(integrator.fsalfirst, integrator.uprev, integrator.p, integrator.t) # pre-start FSAL
    return OrdinaryDiffEqCore.increment_nf!(integrator.stats, 1)
end

@muladd function perform_step!(integrator, cache::VCABM5Cache, repeat_step = false)
    @inbounds begin
        (; t, dt, uprev, u, f, p) = integrator
        (;
            k4, dts, g, ϕ_n, ϕ_np1, ϕstar_n, ϕstar_nm1,
            order, atmp, utilde, rk4cache, thread,
        ) = cache
        k1 = integrator.fsalfirst
        if integrator.u_modified
            cache.step = 1
        end
        k = cache.step
        tmp = dts[5]
        if k == 5
            dts[5] = dts[4]
            dts[4] = dts[3]
            dts[3] = dts[2]
            dts[2] = dts[1]
            dts[1] = dt
        elseif k == 1
            dts[1] = dt
            cache.step += 1
        elseif k == 2
            dts[2] = dts[1]
            dts[1] = dt
            cache.step += 1
        elseif k == 3
            dts[3] = dts[2]
            dts[2] = dts[1]
            dts[1] = dt
            cache.step += 1
        elseif k == 4
            dts[4] = dts[3]
            dts[3] = dts[2]
            dts[2] = dts[1]
            dts[1] = dt
            cache.step += 1
        end
        ϕ_and_ϕstar!(cache, k1, 5)
        if k <= 4
            rk4cache.fsalfirst .= k1
            perform_step!(integrator, rk4cache)
            integrator.fsallast .= rk4cache.k
        else
            g_coefs!(cache, 6)
            @.. broadcast = false thread = thread u = muladd(g[1], ϕstar_n[1], uprev)
            @.. broadcast = false thread = thread u = muladd(g[2], ϕstar_n[2], u)
            @.. broadcast = false thread = thread u = muladd(g[3], ϕstar_n[3], u)
            @.. broadcast = false thread = thread u = muladd(g[4], ϕstar_n[4], u)
            f(k4, u, p, t + dt)
            OrdinaryDiffEqCore.increment_nf!(integrator.stats, 1)
            ϕ_np1!(cache, k4, 6)
            @.. broadcast = false thread = thread u = muladd(g[6 - 1], ϕ_np1[6 - 1], u)
            if integrator.opts.adaptive
                @.. broadcast = false thread = thread utilde = (g[6] - g[6 - 1]) * ϕ_np1[end]
                calculate_residuals!(
                    atmp, utilde, uprev, u, integrator.opts.abstol,
                    integrator.opts.reltol, integrator.opts.internalnorm,
                    t
                )
                integrator.EEst = integrator.opts.internalnorm(atmp, t)
                if integrator.EEst > one(integrator.EEst)
                    dts[1] = dts[2]
                    dts[2] = dts[3]
                    dts[4] = dts[5]
                    dts[5] = tmp
                    return nothing
                end
            end
            cache.ϕstar_nm1[1] .= ϕstar_n[1]
            cache.ϕstar_nm1[2] .= ϕstar_n[2]
            cache.ϕstar_nm1[3] .= ϕstar_n[3]
            cache.ϕstar_nm1[4] .= ϕstar_n[4]
            f(k4, u, p, t + dt)
            OrdinaryDiffEqCore.increment_nf!(integrator.stats, 1)
        end
        cache.ϕstar_nm1, cache.ϕstar_n = ϕstar_n, ϕstar_nm1
        return nothing
    end # inbounds
end

# VCABM

function initialize!(integrator, cache::VCABMConstantCache)
    integrator.fsalfirst = integrator.f(integrator.uprev, integrator.p, integrator.t) # Pre-start fsal
    OrdinaryDiffEqCore.increment_nf!(integrator.stats, 1)
    integrator.kshortsize = 2
    integrator.k = typeof(integrator.k)(undef, integrator.kshortsize)

    # Avoid undefined entries if k is an array of arrays
    integrator.fsallast = zero(integrator.fsalfirst)
    integrator.k[1] = integrator.fsalfirst
    return integrator.k[2] = integrator.fsallast
end

@muladd function perform_step!(integrator, cache::VCABMConstantCache, repeat_step = false)
    @inbounds begin
        (; t, dt, uprev, u, f, p) = integrator
        (; dts, g, ϕ_n, ϕ_np1, ϕstar_n, ϕstar_nm1, order, max_order) = cache
        k1 = integrator.fsalfirst
        step = integrator.iter
        k = order
        tmp = dts[13]
        for i in 12:-1:1
            dts[i + 1] = dts[i]
        end
        dts[1] = dt
        ϕ_and_ϕstar!(cache, k1, k)
        g_coefs!(cache, k + 1)
        u = muladd(g[1], ϕstar_n[1], uprev)
        for i in 2:(k - 1)
            u = muladd(g[i], ϕstar_n[i], u)
        end
        du_np1 = f(u, p, t + dt)
        OrdinaryDiffEqCore.increment_nf!(integrator.stats, 1)
        ϕ_np1!(cache, du_np1, k + 1)
        u = muladd(g[k], ϕ_np1[k], u)
        if integrator.opts.adaptive
            utilde = (g[k + 1] - g[k]) * ϕ_np1[k + 1]
            atmp = calculate_residuals(
                utilde, uprev, u, integrator.opts.abstol,
                integrator.opts.reltol, integrator.opts.internalnorm,
                t
            )
            integrator.EEst = integrator.opts.internalnorm(atmp, t)
            if integrator.EEst > one(integrator.EEst)
                for i in 1:12
                    dts[i] = dts[i + 1]
                end
                dts[13] = tmp
                return nothing
            end
            integrator.fsallast = f(u, p, t + dt)
            OrdinaryDiffEqCore.increment_nf!(integrator.stats, 1)
            if step <= 4 || order < 3
                cache.order = min(order + 1, 3)
            else
                # utildem2 = dt * γstar[(k-2)+1] * ϕ_np1[k-1]
                utildem2 = (g[k - 1] - g[k - 2]) * ϕ_np1[k - 1]
                # utildem1 = dt * γstar[(k-1)+1] * ϕ_np1[k]
                utildem1 = (g[k] - g[k - 1]) * ϕ_np1[k]
                expand_ϕ_and_ϕstar!(cache, k + 1)
                ϕ_np1!(cache, integrator.fsallast, k + 2)
                utildep1 = dt * γstar[(k + 1) + 1] * ϕ_np1[k + 2]
                atmpm2 = calculate_residuals(
                    utildem2, uprev, u, integrator.opts.abstol,
                    integrator.opts.reltol,
                    integrator.opts.internalnorm, t
                )
                atmpm1 = calculate_residuals(
                    utildem1, uprev, u, integrator.opts.abstol,
                    integrator.opts.reltol,
                    integrator.opts.internalnorm, t
                )
                atmpp1 = calculate_residuals(
                    utildep1, uprev, u, integrator.opts.abstol,
                    integrator.opts.reltol,
                    integrator.opts.internalnorm, t
                )
                errm2 = integrator.opts.internalnorm(atmpm2, t)
                errm1 = integrator.opts.internalnorm(atmpm1, t)
                errp1 = integrator.opts.internalnorm(atmpp1, t)
                if max(errm2, errm1) <= integrator.EEst
                    cache.order = order - 1
                elseif errp1 < integrator.EEst
                    cache.order = min(order + 1, max_order)
                    integrator.EEst = one(integrator.EEst)   # for keeping the stepsize constant in the next step
                end # if
            end # step <= 4
        end # integrator.opts.adaptive
        cache.ϕstar_nm1, cache.ϕstar_n = ϕstar_n, ϕstar_nm1
        integrator.k[1] = integrator.fsalfirst
        integrator.k[2] = integrator.fsallast
        integrator.u = u
        return nothing
    end
end

function initialize!(integrator, cache::VCABMCache)
    (; fsalfirst, k4) = cache

    integrator.kshortsize = 2
    resize!(integrator.k, integrator.kshortsize)
    integrator.k[1] = integrator.fsalfirst
    integrator.k[2] = integrator.fsallast
    integrator.f(integrator.fsalfirst, integrator.uprev, integrator.p, integrator.t) # pre-start FSAL
    return OrdinaryDiffEqCore.increment_nf!(integrator.stats, 1)
end

@muladd function perform_step!(integrator, cache::VCABMCache, repeat_step = false)
    @inbounds begin
        (; t, dt, uprev, u, f, p) = integrator
        (;
            k4, dts, g, ϕ_n, ϕ_np1, ϕstar_n, ϕstar_nm1, order, max_order, utilde,
            utildem2, utildem1, utildep1, atmp, atmpm1, atmpm2, atmpp1, thread,
        ) = cache
        k1 = integrator.fsalfirst
        step = integrator.iter
        k = order
        tmp = dts[13]
        for i in 12:-1:1
            dts[i + 1] = dts[i]
        end
        dts[1] = dt
        ϕ_and_ϕstar!(cache, k1, k)
        g_coefs!(cache, k + 1)
        # unroll the predictor once
        @.. broadcast = false thread = thread u = muladd(g[1], ϕstar_n[1], uprev)
        for i in 2:(k - 1)
            @.. broadcast = false thread = thread u = muladd(g[i], ϕstar_n[i], u)
        end
        f(k4, u, p, t + dt)
        OrdinaryDiffEqCore.increment_nf!(integrator.stats, 1)
        ϕ_np1!(cache, k4, k + 1)
        @.. broadcast = false thread = thread u = muladd(g[k], ϕ_np1[k], u)
        if integrator.opts.adaptive
            @.. broadcast = false thread = thread utilde = (g[k + 1] - g[k]) * ϕ_np1[k + 1]
            calculate_residuals!(
                atmp, utilde, uprev, u, integrator.opts.abstol,
                integrator.opts.reltol, integrator.opts.internalnorm, t
            )
            integrator.EEst = integrator.opts.internalnorm(atmp, t)
            if integrator.EEst > one(integrator.EEst)
                for i in 1:12
                    dts[i] = dts[i + 1]
                end
                dts[13] = tmp
                return nothing
            end
            f(k4, u, p, t + dt)
            OrdinaryDiffEqCore.increment_nf!(integrator.stats, 1)
            if step <= 4 || order < 3
                cache.order = min(order + 1, 3)
            else
                # @.. broadcast=false thread=thread utildem2 = dt * γstar[(k-2)+1] * ϕ_np1[k-1]
                @.. broadcast = false thread = thread utildem2 = (g[k - 1] - g[k - 2]) *
                    ϕ_np1[k - 1]
                # @.. broadcast=false thread=thread utildem1 = dt * γstar[(k-1)+1] * ϕ_np1[k]
                @.. broadcast = false thread = thread utildem1 = (g[k] - g[k - 1]) * ϕ_np1[k]
                expand_ϕ_and_ϕstar!(cache, k + 1)
                ϕ_np1!(cache, k4, k + 2)
                @.. broadcast = false thread = thread utildep1 = dt * γstar[(k + 1) + 1] *
                    ϕ_np1[k + 2]
                calculate_residuals!(
                    atmpm2, utildem2, uprev, u, integrator.opts.abstol,
                    integrator.opts.reltol, integrator.opts.internalnorm,
                    t
                )
                calculate_residuals!(
                    atmpm1, utildem1, uprev, u, integrator.opts.abstol,
                    integrator.opts.reltol, integrator.opts.internalnorm,
                    t
                )
                calculate_residuals!(
                    atmpp1, utildep1, uprev, u, integrator.opts.abstol,
                    integrator.opts.reltol, integrator.opts.internalnorm,
                    t
                )
                errm2 = integrator.opts.internalnorm(atmpm2, t)
                errm1 = integrator.opts.internalnorm(atmpm1, t)
                errp1 = integrator.opts.internalnorm(atmpp1, t)
                if max(errm2, errm1) <= integrator.EEst
                    cache.order = order - 1
                elseif errp1 < integrator.EEst
                    cache.order = min(order + 1, max_order)
                    integrator.EEst = one(integrator.EEst)    # for keeping the stepsize constant in the next step
                end
            end
        end
        cache.ϕstar_nm1, cache.ϕstar_n = ϕstar_n, ϕstar_nm1
        return nothing
    end # inbounds
end

# Solving Ordinary Differential Equations I: Nonstiff Problems
# by Ernst Hairer, Gerhard Wanner, and Syvert P Norsett.
# III.5 Variable Step Size Multistep Methods: Formulae 5.9
function ϕ_and_ϕstar!(cache, du, k)
    return @inbounds begin
        (; dts, ϕstar_nm1, ϕ_n, ϕstar_n, β) = cache
        ξ = dt = dts[1]
        ξ0 = zero(dt)
        β[1] = one(dt)
        if cache isa OrdinaryDiffEqMutableCache
            ϕ_n[1] .= du
            ϕstar_n[1] .= du
        else
            ϕ_n[1] = du
            ϕstar_n[1] = du
        end
        for i in 2:k
            ξ0 += dts[i]
            β[i] = β[i - 1] * ξ / ξ0
            ξ += dts[i]
            if cache isa OrdinaryDiffEqMutableCache
                @.. broadcast = false ϕ_n[i] = ϕ_n[i - 1] - ϕstar_nm1[i - 1]
                @.. broadcast = false ϕstar_n[i] = β[i] * ϕ_n[i]
            else
                ϕ_n[i] = ϕ_n[i - 1] - ϕstar_nm1[i - 1]
                ϕstar_n[i] = β[i] * ϕ_n[i]
            end
        end
    end # inbounds
end

function ϕ_and_ϕstar!(cache::Union{VCABMConstantCache, VCABMCache}, du, k)
    return @inbounds begin
        (; dts, ϕstar_nm1, ϕ_n, ϕstar_n, β) = cache
        ξ = dt = dts[1]
        ξ0 = zero(dt)
        β[1] = one(dt)
        if cache isa OrdinaryDiffEqMutableCache
            ϕ_n[1] .= du
            ϕstar_n[1] .= du
        else
            ϕ_n[1] = du
            ϕstar_n[1] = du
        end
        for i in 2:k
            ξ0 += dts[i]
            β[i] = β[i - 1] * ξ / ξ0
            ξ += dts[i]
            if cache isa OrdinaryDiffEqMutableCache
                @.. broadcast = false ϕ_n[i] = ϕ_n[i - 1] - ϕstar_nm1[i - 1]
                @.. broadcast = false ϕstar_n[i] = β[i] * ϕ_n[i]
            else
                ϕ_n[i] = ϕ_n[i - 1] - ϕstar_nm1[i - 1]
                ϕstar_n[i] = β[i] * ϕ_n[i]
            end
        end
        cache.ξ = ξ
        cache.ξ0 = ξ0
    end # inbounds
end

function expand_ϕ_and_ϕstar!(cache, i)
    (; ξ, ξ0, β, dts, ϕstar_nm1, ϕ_n, ϕstar_n) = cache
    ξ0 += dts[i]
    β[i] = β[i - 1] * ξ / ξ0
    return if cache isa OrdinaryDiffEqMutableCache
        @.. broadcast = false ϕ_n[i] = ϕ_n[i - 1] - ϕstar_nm1[i - 1]
        @.. broadcast = false ϕstar_n[i] = β[i] * ϕ_n[i]
    else
        ϕ_n[i] = ϕ_n[i - 1] - ϕstar_nm1[i - 1]
        ϕstar_n[i] = β[i] * ϕ_n[i]
    end
end

function ϕ_np1!(cache, du_np1, k)
    return @inbounds begin
        (; ϕ_np1, ϕstar_n) = cache
        for i in 1:k
            if i != 1
                if cache isa OrdinaryDiffEqMutableCache
                    @.. broadcast = false ϕ_np1[i] = ϕ_np1[i - 1] - ϕstar_n[i - 1]
                else
                    ϕ_np1[i] = ϕ_np1[i - 1] - ϕstar_n[i - 1]
                end
            else
                if cache isa OrdinaryDiffEqMutableCache
                    ϕ_np1[i] .= du_np1
                else
                    ϕ_np1[i] = du_np1
                end
            end
        end
    end #inbounds
end

# Solving Ordinary Differential Equations I: Nonstiff Problems
# by Ernst Hairer, Gerhard Wanner, and Syvert P Norsett.
# III.5 Variable Step Size Multistep Methods: Formulae 5.9 & 5.10
# ------------------------------------------------------------
# Note that `g` is scaled by `dt` in here
function g_coefs!(cache, k)
    return @inbounds begin
        (; dts, c, g) = cache
        ξ = dt = dts[1]
        for i in 1:k
            if i > 2
                ξ += dts[i - 1]
            end
            for q in 1:(k - (i - 1))
                if i > 2
                    c[i, q] = muladd(-dt / ξ, c[i - 1, q + 1], c[i - 1, q])
                elseif i == 1
                    c[i, q] = inv(q)
                elseif i == 2
                    c[i, q] = inv(q * (q + 1))
                end
            end # q
            g[i] = c[i, 1] * dt
        end # i
    end # inbounds
end

# Coefficients for the implicit Adams methods
const global γstar = [
    1,
    -1 / 2,
    -1 / 12,
    -1 / 24,
    -19 / 720,
    -3 / 160,
    -863 / 60480,
    -275 / 24192,
    -33953 / 3628800,
    -0.00789255,
    -0.00678585,
    -0.00592406,
    -0.00523669,
    -0.0046775,
    -0.00421495,
    -0.0038269,
]

# Adams Bashforth and Adams moulton methods
reference = """E. Hairer, S. P. Norsett, G. Wanner, Solving Ordinary Differential Equations I, Nonstiff
Problems. Computational Mathematics (2nd revised ed.), Springer (1996) doi:
https://doi.org/10.1007/978-3-540-78862-1"""

keyword_default_description = """
- `thread`: determines whether internal broadcasting on appropriate CPU arrays should be serial (`thread = OrdinaryDiffEq.False()`) or use multiple threads (`thread = OrdinaryDiffEq.True()`) when Julia is started with multiple threads.
"""

keyword_default = """
thread = OrdinaryDiffEq.False(),
"""

@doc generic_solver_docstring(
    "The 3-step third order multistep method.
        Ralston's Second Order Method is used to calculate starting values.",
    "AB3",
    "Adams-Bashforth Explicit Method",
    reference,
    keyword_default_description,
    keyword_default
)
Base.@kwdef struct AB3{Thread} <: OrdinaryDiffEqAlgorithm
    thread::Thread = False()
end

@doc generic_solver_docstring(
    "The 4-step fourth order multistep method.
    Runge-Kutta method of order 4 is used to calculate starting values.",
    "AB4",
    "Adams-Bashforth Explicit Method",
    reference,
    keyword_default_description,
    keyword_default
)
Base.@kwdef struct AB4{Thread} <: OrdinaryDiffEqAlgorithm
    thread::Thread = False()
end

@doc generic_solver_docstring(
    "The 5-step fifth order multistep method.
    Ralston's 3rd order Runge-Kutta method is used to calculate starting values.",
    "AB5",
    "Adams-Bashforth Explicit Method",
    reference,
    keyword_default_description,
    keyword_default
)
Base.@kwdef struct AB5{Thread} <: OrdinaryDiffEqAlgorithm
    thread::Thread = False()
end

@doc generic_solver_docstring(
    "It is third order method.
    In ABM32, AB3 works as predictor and Adams Moulton 2-steps method works as Corrector.
    Ralston's Second Order Method is used to calculate starting values.",
    "ABM32",
    "Adams-Bashforth Explicit Method",
    reference,
    keyword_default_description,
    keyword_default
)
Base.@kwdef struct ABM32{Thread} <: OrdinaryDiffEqAlgorithm
    thread::Thread = False()
end

@doc generic_solver_docstring(
    "It is fourth order method.
    In ABM43, AB4 works as predictor and Adams Moulton 3-steps method works as Corrector.
    Runge-Kutta method of order 4 is used to calculate starting values.",
    "ABM43",
    "Adams-Bashforth Explicit Method",
    reference,
    keyword_default_description,
    keyword_default
)
Base.@kwdef struct ABM43{Thread} <: OrdinaryDiffEqAlgorithm
    thread::Thread = False()
end

@doc generic_solver_docstring(
    "It is fifth order method.
    In ABM54, AB5 works as predictor and Adams Moulton 4-steps method works as Corrector.
    Runge-Kutta method of order 4 is used to calculate starting values.",
    "ABM54",
    "Adams-Bashforth Explicit Method",
    reference,
    keyword_default_description,
    keyword_default
)
Base.@kwdef struct ABM54{Thread} <: OrdinaryDiffEqAlgorithm
    thread::Thread = False()
end

# Variable Step Size Adams methods

@doc generic_solver_docstring(
    "The 3rd order Adams method.
    Bogacki-Shampine 3/2 method is used to calculate starting values.",
    "VCAB3",
    "Adams explicit Method",
    reference,
    keyword_default_description,
    keyword_default
)
Base.@kwdef struct VCAB3{Thread} <: OrdinaryDiffEqAdaptiveAlgorithm
    thread::Thread = False()
end

@doc generic_solver_docstring(
    "The 4th order Adams method.
    Runge-Kutta 4 is used to calculate starting values.",
    "VCAB4",
    "Adams explicit Method",
    reference,
    keyword_default_description,
    keyword_default
)
Base.@kwdef struct VCAB4{Thread} <: OrdinaryDiffEqAdaptiveAlgorithm
    thread::Thread = False()
end

@doc generic_solver_docstring(
    "The 5th order Adams method.
    Runge-Kutta 4 is used to calculate starting values.",
    "VCAB5",
    "Adams explicit Method",
    reference,
    keyword_default_description,
    keyword_default
)
Base.@kwdef struct VCAB5{Thread} <: OrdinaryDiffEqAdaptiveAlgorithm
    thread::Thread = False()
end

@doc generic_solver_docstring(
    "The 3rd order Adams-Moulton method.
    Bogacki-Shampine 3/2 method is used to calculate starting values.",
    "VCABM3",
    "Adams explicit Method",
    reference,
    keyword_default_description,
    keyword_default
)
Base.@kwdef struct VCABM3{Thread} <: OrdinaryDiffEqAdaptiveAlgorithm
    thread::Thread = False()
end

@doc generic_solver_docstring(
    "The 4th order Adams-Moulton method.
    Runge-Kutta 4 is used to calculate starting values.",
    "VCABM4",
    "Adams explicit Method",
    reference,
    keyword_default_description,
    keyword_default
)
Base.@kwdef struct VCABM4{Thread} <: OrdinaryDiffEqAdaptiveAlgorithm
    thread::Thread = False()
end

@doc generic_solver_docstring(
    "The 5th order Adams-Moulton method.
    Runge-Kutta 4 is used to calculate starting values.",
    "VCABM5",
    "Adams explicit Method",
    reference,
    keyword_default_description,
    keyword_default
)
Base.@kwdef struct VCABM5{Thread} <: OrdinaryDiffEqAdaptiveAlgorithm
    thread::Thread = False()
end

# Variable Order and Variable Step Size Adams methods

@doc generic_solver_docstring(
    "An adaptive order adaptive time Adams Moulton method.
    It uses an order adaptivity algorithm is derived from Shampine's DDEABM.",
    "VCABM",
    "adaptive order Adams explicit Method",
    reference,
    keyword_default_description,
    keyword_default
)
Base.@kwdef struct VCABM{Thread} <: OrdinaryDiffEqAdamsVarOrderVarStepAlgorithm
    thread::Thread = False()
end

alg_order(alg::AB3) = 3
alg_order(alg::ABM32) = 3
alg_order(alg::AB4) = 4
alg_order(alg::ABM43) = 4
alg_order(alg::AB5) = 5
alg_order(alg::ABM54) = 5
alg_order(alg::VCAB3) = 3
alg_order(alg::VCAB4) = 4
alg_order(alg::VCAB5) = 5
alg_order(alg::VCABM3) = 3
alg_order(alg::VCABM4) = 4
alg_order(alg::VCABM5) = 5
alg_order(alg::VCABM) = 1  #dummy value

isstandard(alg::VCABM) = true

using OrdinaryDiffEqAdamsBashforthMoulton, DiffEqDevTools, DiffEqBase, Test
import ODEProblemLibrary: prob_ode_linear, prob_ode_2Dlinear

probArr = Vector{ODEProblem}(undef, 2)

probArr[1] = prob_ode_linear
probArr[2] = prob_ode_2Dlinear

function fixed_step_ϕstar(k)
    ∇ = Vector{typeof(k[end][1])}(undef, 3)
    ∇[1] = k[end][1]
    ∇[2] = ∇[1] - k[end - 1][1]
    ∇[3] = ∇[2] - k[end - 1][1] + k[end - 2][1]
    return ∇
end

for i in 1:2
    prob = probArr[i]
    dt = 1 // 256
    integrator = init(prob, VCAB3(), dt = dt, adaptive = false)
    for i in 1:3
        step!(integrator)
    end
    @test integrator.cache.g == [1, 1 / 2, 5 / 12] * dt
    step!(integrator)
    @test integrator.cache.g == [1, 1 / 2, 5 / 12] * dt
    step!(integrator)
    @test integrator.cache.g == [1, 1 / 2, 5 / 12] * dt
end

for i in 1:2
    prob = probArr[i]
    # VCAB3
    integrator = init(prob, VCAB3(), dt = 1 // 256, adaptive = false)
    for i in 1:3
        step!(integrator)
    end
    # in perform_step, after swapping array using pointer, ϕstar_nm1 points to ϕstar_n
    @test integrator.cache.ϕstar_nm1 == fixed_step_ϕstar(integrator.sol.k)
    step!(integrator)
    @test integrator.cache.ϕstar_nm1 == fixed_step_ϕstar(integrator.sol.k)
    step!(integrator)
    @test integrator.cache.ϕstar_nm1 == fixed_step_ϕstar(integrator.sol.k)

    # VCAB4
    sol1 = solve(prob, VCAB4(), dt = 1 // 256, adaptive = false)
    sol2 = solve(prob, AB4(), dt = 1 // 256)
    @test sol1.u ≈ sol2.u

    # VCAB5
    sol1 = solve(prob, VCAB5(), dt = 1 // 256, adaptive = false)
    sol2 = solve(prob, AB5(), dt = 1 // 256)
    @test sol1.u ≈ sol2.u
end

using OrdinaryDiffEqAdamsBashforthMoulton, ODEProblemLibrary
import OrdinaryDiffEqCore: OrdinaryDiffEqAdaptiveAlgorithm
using Test
using Static

algorithms = [
    AB3, AB4, AB5, ABM32, ABM43, ABM54, VCAB3, VCAB4, VCAB5, VCABM3, VCABM4, VCABM5, VCABM,
]

problem = ODEProblemLibrary.prob_ode_linear

@testset "Regression test for threading versions vs non threading versions" begin
    @testset "$ALG" for ALG in algorithms
        if ALG isa OrdinaryDiffEqAdaptiveAlgorithm
            sol_thread = solve(problem, ALG(Static.True()))
            sol_nothread = solve(problem, ALG(Static.False()))
        else
            sol_thread = solve(problem, ALG(Static.True()), dt = 1 // 2^9)
            sol_nothread = solve(problem, ALG(Static.False()), dt = 1 // 2^9)
        end
        @test all(sol_nothread .== sol_thread)
    end
end

module OrdinaryDiffEqAdamsBashforthMoulton

import OrdinaryDiffEqCore: OrdinaryDiffEqMutableCache, OrdinaryDiffEqConstantCache, @cache,
    alg_cache,
    initialize!, perform_step!, alg_order, isstandard,
    OrdinaryDiffEqAlgorithm,
    OrdinaryDiffEqAdaptiveAlgorithm,
    OrdinaryDiffEqAdamsVarOrderVarStepAlgorithm,
    constvalue, calculate_residuals, calculate_residuals!,
    trivial_limiter!, get_fsalfirstlast,
    generic_solver_docstring,
    full_cache,
    _bool_to_ADType, @SciMLMessage
import OrdinaryDiffEqLowOrderRK: BS3ConstantCache, BS3Cache, RK4ConstantCache, RK4Cache
import RecursiveArrayTools: recursivefill!
using MuladdMacro, FastBroadcast
import Static: False
import OrdinaryDiffEqCore

using Reexport
@reexport using SciMLBase

include("algorithms.jl")
include("alg_utils.jl")
include("adams_bashforth_moulton_caches.jl")
include("adams_utils.jl")
include("adams_bashforth_moulton_perform_step.jl")

export AB3, AB4, AB5, ABM32, ABM43, ABM54, VCAB3,
    VCAB4, VCAB5, VCABM3, VCABM4, VCABM5, VCABM

end
